/**
 * 
 */
package core;

import java.awt.Canvas;
import java.awt.GraphicsConfiguration;
import java.awt.Graphics;
import java.awt.Color;
import java.awt.event.KeyListener;

import java.awt.event.*;

/**
 * @author tekkno
 * 
 */
public class DebugCanvas extends Canvas  {
	Position3DDebug obj;
	private static boolean debug = false;
	/**
	 * 
	 */
	public DebugCanvas(Position3DDebug obj) {
		this.obj = obj;
	}

	/**
	 * @param arg0
	 */
	public DebugCanvas(GraphicsConfiguration arg0) {
		super(arg0);
	}

	public void paint(Graphics g) {

		// g.drawLine(0, 0, 100, 100);
		int height = this.getSize().height;
		int width = this.getSize().width;
		int y = (int) Math.round(height*(1+obj.getFrameSize()));
		int x = (int) Math.round(width*(1+obj.getFrameSize()));
		
		double inverse = 1 / (1 + obj.getFrameSize());
		
		g.clearRect(0, 0, y, x);
		if(debug) System.out.println("------- DRAWING -------");
		g.setColor(Color.RED);
		g.drawRect(
				(int)Math.round(obj.getFrameSize() * width), 
				(int)Math.round(obj.getFrameSize()	* height), 
				(int)Math.round(width - width * inverse), 
				(int)Math.round(height - inverse * height));
		for (Smooth s : obj.getSlights())
			if (s != null) {
				if (!s.isRealLight())
					g.setColor(Color.RED);
				else
					g.setColor(Color.BLACK);
				g.drawOval((int) 
						Math.round(s.getX() * x * inverse), 
						(int) Math.round(s.getY()	* y * inverse),
						(int)Math.round(s.getSize()), (int)Math.round(s.getSize()));
				//System.out.println("drawing" + s);
			}
	}
	
	
	
	
	

}
