package core;

import java.awt.geom.Point2D;
import wiiremotej.IRLight;
import java.util.ArrayList;
import java.util.Stack;

public class IRLightManager extends Point2D {

	ArrayList<Smooth> irLights = new ArrayList<Smooth>(); 
	int activIRLights = 0;
	int foundIRLights = 0;
	private double dist = 0d;
	private boolean debug = false;
	
	@Override
	public double getX() {
		// TODO Auto-generated method stub
		return getPossition()[0];
	}

	@Override
	public double getY() {
		
		return getPossition()[1];
	}
	
	public double getZ(){
		return getPossition()[2];
	}

	@Override
	public void setLocation(double arg0, double arg1) {
		
		

	}

	

	/**
	 * @return the irLights
	 */
	public ArrayList<Smooth> getIrLights() {
		return irLights;
	}

	private Smooth findClosest(IRLight light){
		double dist = 200000;
		Smooth closest = null;
		for(Smooth s :irLights){
			double fdist = s.distance(light.getX(), light.getY());
			if(fdist < dist){
				dist = fdist;
				closest = s;
			}
		}
		return closest;
	}
	
	private boolean known(IRLight light){
		if(light!= null){
			Smooth testingLight = new Smooth(light);
			for(Smooth irl :irLights ){
				if(irl.equals(testingLight))
					return true;
			}
		}
		return false;
			
	}
	
	
	public void resetLights(){
		irLights.clear();
		activIRLights = 0;
	}
	
	public void update(IRLight lights[]){
		foundIRLights = 0;
		for(IRLight irl :lights){
			if (irl != null)
				foundIRLights++;
		}
		
		System.out.print("found IRLights: "+foundIRLights + " / " + irLights.size() + "\t|");
		
		if(foundIRLights > activIRLights){
			
			Stack<Smooth> untaken = new Stack<Smooth>();
			for(IRLight irl :lights)
				//if(irl != null && !known(irl))
				if(irl != null)
					untaken.push(new Smooth(irl));
			
			for(int i=0; i< foundIRLights && lights[i] != null; i++){
				
				//find untaken 
				
				
				
				/*
				 * 
				 * TODO hier spackt es!
				 * 
				 */
				
				//if(irLights.get(i) == null){
					if(untaken.lastElement() != null && !known(lights[i]))
						irLights.add(untaken.pop());
				//}
					
				for(int y = 0; y < irLights.size(); y++)
					if(irLights.get(y)== null)
						irLights.remove(y);
			}
			activIRLights = foundIRLights;
		}
		
		
		//updating and gain information for moving lights which are not found this round
		Stack<Smooth> updatedLights = new Stack<Smooth>();
		double movementX = 0;
		double movementY = 0;
		
		ArrayList<IRLight> notfound = new ArrayList<IRLight>();
		
		for(int i=0; i<4 && lights[i] != null; i++){
			if(lights[i] != null){
				
				Smooth closest = findClosest(lights[i]);
				if(closest != null){
					double beforeX = closest.getX();
					double beforeY = closest.getY();
				
				
					closest.setRealLight(true);
					
					closest.setX(lights[i].getX());
					closest.setY(lights[i].getY());
					closest.setSize(lights[i].getSize());
					System.out.println("size: "+lights[i].getSize());
					updatedLights.add(closest);
					
					movementX += closest.getX() - beforeX;
					movementY += closest.getY() - beforeY;
				} else 
					notfound.add(lights[i]);
					
			}
			/*System.out.println("Ligh: "+i);
			System.out.println("X: "+slights[i].getX());
			System.out.println("Y: "+slights[i].getY());*/
			
		}
		
		
		/*
		 * TODO write hard updates
		 */
		
		if(notfound.size() > 0)
			System.out.println("update me raawwwww");
		
		if(updatedLights.size()>0){
			movementX /= updatedLights.size();
			movementY /= updatedLights.size();
			moveNonFoundLights(movementX, movementY, updatedLights);
		}
		
		clearOutdated();
	}
	
	protected ArrayList<Smooth> getDifferenc(Stack<Smooth> list){
		ArrayList<Smooth> ret = new ArrayList<Smooth>();
		ret.addAll(irLights);
		ret.removeAll(list);
		if(ret.size() > 0)
			return ret;
		else 
			return null;
		
	}
	
	protected void moveNonFoundLights(double x, double y, Stack<Smooth> touched){
		if(touched.size() < irLights.size()){
			
			ArrayList<Smooth> toMove = getDifferenc(touched);
			for(Smooth l : toMove){
				l.setX(l.getX() + x);
				l.setY(l.getY() + y);
				System.out.print("automove : x:" +x+ " y:"+y+" ");
			}
		}
	}
	
	private void clearOutdated(){
		
		if(irLights.size()>2){
			Stack<Smooth> tmp = new Stack<Smooth>();
			for(Smooth light : irLights){
				if(light.isOutdated())
					tmp.add(light);
			}
			if(tmp.size()>0)
			while (irLights.size() > 2)
				irLights.remove(tmp.pop());
		}
		
	}
	
	/*
	 * Visible Lights wurde eingefügt. 
	 * Macht aber Massive Probleme!
	 * 
	 * TODO 
	 * TODO 
	 * TODO
	 * 
	 */
	
	
	public double[] getPossition(){
		double[] xyz = new double[3];
		double max = 0;
		
		double dy = 0;
		double dx = 0;
		//double factor = 200;
		final double factor = 1024/20;
		int visibleLights = 0;
		
		fakeSecondLight();
		
		for(Smooth s : irLights){
			if(s != null && s.isVisible()){
				//add 
				xyz[0] += s.getX();
				xyz[1] += s.getY();
				xyz[2] = 0;
				visibleLights++;
				/*
				max += 1;
				count++;
				if(count > 1){
					dx = s.getX()-s.getX();
					dy = irLights[0].getY()-irLights[1].getY();
				}
				*/
			}
		}
		
		
		if(visibleLights < 2)
			visibleLights++;
		//centern
		max = (max / visibleLights) * (factor / 2 );
		
		//Z
		if(irLights.size() > 1){
			dx = irLights.get(0).getX()-irLights.get(1).getX();
			dy = irLights.get(0).getY()-irLights.get(1).getY();
			
		}
		
		
		xyz[0] = (xyz[0] /visibleLights-0.5)*factor - max;
		xyz[1] = (xyz[1] / visibleLights-0.5)*factor - max;
		
		
		
		dist = Math.sqrt(dx * dx + dy * dy);
		
		xyz[2] = (double) 20/dist;//*factor;
		if (debug) System.out.print(dist);
		return xyz;
	}
	
	public double getLastKnowDist(){
		return dist;
	}
	
	
	public double[] fakeSecondLight(){
		
		//cleanup if there are enough lights
		if(irLights.size() > 1){
			Stack<Smooth> buf = new Stack<Smooth>();
			for(Smooth l : irLights)
				if(!l.isRealLight())
					buf.add(l);
			if(buf.size() > 0)
				irLights.retainAll(buf);
		}
		
		if(irLights.size() == 1){
			double frame = getLastKnowDist();
			//determ which light has to be faked
			
			//left
			Smooth light = irLights.get(0);
			Smooth newLight = new Smooth();
			newLight.setRealLight(false);
			//selbe höhe
			newLight.setY(light.getY());
			if(light.getX() <= frame){
				
				newLight.setX(light.getX() - frame);
				
			
			} else
				//right
				if (light.getX() > (1 - frame)){
					newLight.setY(light.getX() + frame);
				}
			irLights.add(newLight);
		}
		return null;
	}
}
