package core;
/**
 * 
 */



import java.io.IOException;
import java.util.ArrayList;

import wiiremotej.IRLight;
import wiiremotej.WiiRemote;
import wiiremotej.WiiRemoteExtension;
import wiiremotej.WiiRemoteExtensionFactory;
import wiiremotej.WiiRemoteJ;
import wiiremotej.event.WRButtonEvent;
import wiiremotej.event.WRExtensionEvent;
import wiiremotej.event.WRIREvent;
import wiiremotej.event.WiiRemoteAdapter;
import wiiremotej.event.WiiRemoteDiscoveredEvent;
import wiiremotej.event.WiiRemoteDiscoveryListener;



/**
 * @author tekkno
 * 
 */
public class PluginWii implements Position3DDebug {
	private WiiRemote remote = null;
	boolean debug = true;
	ArrayList<Smooth> slights;
	DebugWindow debugw;
	private IRLightManager irLManager = null;
	/**
	 * 
	 */
	public PluginWii() {
		slights = new ArrayList<Smooth>();
		connect();
		if(debug){
			debugw = new DebugWindow(this);
			debugw.setVisible(true);
		}
		
	}

	/*public int count<TItem>(IEnumerable<TItem> list){
		return 0;
	}
	
	public static TConvert Convert<TConvert>(Object toConvert){
		if(toConvert is TConvert)
			return (TConvert)toConvert;
		else if(toConvert==null){
			if(SupportsNull(typeof(TConvert)))
				return null;
			else
				//throw new Exception("bla nicht null usw");
				return default(TConvert);
		}
		else if(toConvert is String)
			return toConvert.ToStrin();
		else 
			return (TConvert)Converters.ConvertTo(typeof(TConvert),toConvert);
	}*/

	//int cnt=count<Buerger>(burgerliste);
//int? myInt=Convert<int?>(datareader["SpalteBla"]);
	
	
	
	public void connect() {
		
		try {
			
			WiiRemoteJ.setConsoleLoggingAll();

			WiiRemoteDiscoveryListener wrdlistener = new WiiRemoteDiscoveryListener() {

				public void wiiRemoteDiscovered(WiiRemoteDiscoveredEvent evt) {
					evt.getWiiRemote().addWiiRemoteListener(
							new WiiListener(evt.getWiiRemote()));
				}

				public void findFinished(int numberFound) {
					System.out.println("Found " + numberFound + " remotes!");
				}
			};

			// Extension with 6 payload
			WiiRemoteExtension wrx = new WiiRemoteExtension(6) {

				public boolean isPayloadValid(int payload) {
                    return payload == getPayload();
                }

               
                public void decryptExtensionInput(byte[] arg0, int arg1, int arg2) {
                    //this may or may not be necessary, depending on
                    //how Arduino works
                }

               
                public short getCode() {
                    return (short)0x52;
                }

               
                public WRExtensionEvent createWRExtensionEvent(WiiRemote remote, byte[] arg1, int arg2) {
                    try {

                        System.out.println(remote.getBluetoothAddress());
                       
                    } catch (IOException ex) {}
                    throw new UnsupportedOperationException("Not supported yet.4");
                    //this needs to parse the data and return an event.
                   //return null; //for now I'll have it return null
                } 
			};

			// Find and connect to a Wii Remote
			remote = WiiRemoteJ.findRemote();
			if(remote != null){
				//WiiRemoteExtensionFactory factory = remote.getExtensionFactory();
				//factory.removeExtension(((short) 0x52));
				//factory.registerWiiRemoteExtension(wrx);
				
				
				
				/*working*/
				//remote.setIRSensorEnabled(true, WRIREvent.BASIC);
				/*testing*/
				remote.setIRSensorEnabled(true, WRIREvent.BASIC);
				
				
				
				
				remote.addWiiRemoteListener(new WiiListener(remote));
				remote.setAccelerometerEnabled(true);
				
				// remote.setInterleaved(false);
	
				WiiRemoteExtensionFactory wrxf = WiiRemoteExtensionFactory
						.getDefault();
	
				// short s = (short)123;
				// wrxf.createWiiRemoteExtension(s);
	
				//factory.registerWiiRemoteExtension(wrx);
				
				wrxf.registerWiiRemoteExtension(wrx);
				
				irLManager = new IRLightManager();
				
				
				Thread.sleep(400);
			} else {
				System.err.println("no wii detected");
			}
		} catch (Exception e) {
			e.printStackTrace();
		}

	}

	public boolean isConnected(){
		if (remote == null)
			return false;
		return remote.isConnected();
	}
	
	public double[] getPossition(){
		/*double[] xyz = new double[3];
		double max = 0;
		int count = 0;
		double dy = 0;
		double dx = 0;
		double factor = 50;
		
		for(int i=0; i<4 && slights[i] != null; i++){
			xyz[0] += slights[i].getX();
			xyz[1] += slights[i].getY();
			xyz[2] = 0;
			max += 1;
			count++;
			if(count > 1){
				dx = slights[0].getX()-slights[1].getX();
				dy = slights[0].getY()-slights[1].getY();
			}
		}
		//centern
		max = (max / count) * (factor / 2 );
		
		xyz[0] = (xyz[0] / count)*factor - max;
		xyz[1] = (xyz[1] / count)*factor - max;
		
		xyz[2] = (float)Math.sqrt(dx * dx + dy * dy)*factor *8;
		System.out.println(xyz[2]);*/
		double[] pos = irLManager.getPossition();
		//pos[0] *= -1;
		pos[1] *= -1;
		pos[2] *= -1;
		return pos;
		//return xyz;
	}
	
	public void close(){
		if(remote != null)
			remote.disconnect();
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
		new PluginWii();
	}
	
	
	
	class WiiListener extends WiiRemoteAdapter {
		private WiiRemote wii;

		public WiiListener(WiiRemote wii) {
			this.wii = wii;
		}
		
		public void IRInputReceived(WRIREvent evt){
			System.out.println("IR recieved");
			
			irLManager.update(evt.getIRLights());
			slights = irLManager.getIrLights();
			try{
				debugw.doUpdate();
			} catch (Exception e) {
				e.printStackTrace();
			}
			
		}
		
		public void buttonInputReceived(WRButtonEvent evt) {
			if (evt.wasPressed(WRButtonEvent.B)){
				wii.disconnect();
				System.exit(0);
				
			} else 
				
					System.out.println(evt.getSource().reportsProcessed);
		}
	}

	/**
	 * @return the slights
	 */
	public ArrayList<Smooth> getSlights() {
		return slights;
	}

	/**
	 * @param slights the slights to set
	 */
	public void setSlights(ArrayList<Smooth> slights) {
		this.slights = slights;
	}

	
	public double getFrameSize() {
		if(irLManager != null)
		return irLManager.getLastKnowDist() / 2 ;
		else return 0;
	}
	
	public void reset(){
		irLManager.resetLights();
	}
	
}
