package core;
import java.awt.geom.Point2D.Double;
import wiiremotej.IRLight;
import java.util.Stack;
/**
 * This class is to make the signal more smooth. 
 * Splinecurves would be awesome and useage of the accellartion to make the signal more
 * accurate 
 */

/**
 * @author tekkno
 *
 */
public class Smooth extends Double implements Comparable{

	
	private Stack<java.lang.Double> valuesX, valuesY;
	private static int neededValues=2;
	private boolean visible = true;
	private int timestamp = 0;
	
	private static int timeout = 1; //time in seconds
	private static double tolleranc = 0.001;
	private boolean realLight = true;
	private double size = 1d;
	/**
	 * 
	 */
	public Smooth() {
		init();
	}

	/**
	 * @param arg0
	 * @param arg1
	 */
	public Smooth(double arg0, double arg1) {
		super(arg0, arg1);
		init();
		// TODO Auto-generated constructor stub
	}
	
	public Smooth(IRLight light){
		super(light.getX(),	light.getY());
		init();
	}
	private void init(){
		valuesX = new Stack<java.lang.Double>();
		valuesY = new Stack<java.lang.Double>();
	}
	
	public boolean isOutdated(){
		if(timestamp > 0 && 
				(((System.currentTimeMillis() / 1000) - timeout) > timestamp))
			return true;
		else 
			return false;
			
	}
	
	private void updateTime(){
		timestamp = Math.round(System.currentTimeMillis() / 1000);
	}
	
	public void setX(double x){
		valuesX.add(new java.lang.Double(x));
		if(valuesX.size() == neededValues){
			double tmp = 0;
			for (java.lang.Double ax : valuesX) {
				tmp += ax;
			}
			this.x = tmp/neededValues;
			valuesX.clear();
		}
		updateTime();
		
	}
	
	public void setY(double y){
		valuesY.add(y);
		if(valuesY.size() == neededValues){
			double tmp = 0;
			for (java.lang.Double ay : valuesY) {
				tmp += ay;
			}
			this.y = tmp/neededValues;
			valuesY.clear();
		}
		updateTime();
	}
	
	
	
	/**
	 * @return the visible
	 */
	public boolean isVisible() {
		return visible;
	}

	/**
	 * @param visible the visible to set
	 */
	public void setVisible(boolean visible) {
		this.visible = visible;
	}

	public int compareTo(Object obj){
		if(obj instanceof Smooth){
			Smooth ob1 = (Smooth) obj;
			if (
					(this.getX() + tolleranc) > ob1.getX() &&
					(this.getX() - tolleranc) < ob1.getX() &&
					(this.getY() + tolleranc) > ob1.getY() &&
					(this.getY() - tolleranc) < ob1.getY()
				) 
				return 1;
			else
				return -1;
				
		}
		return -1;
	}

	/**
	 * @return the realLight
	 */
	public boolean isRealLight() {
		return realLight;
	}

	/**
	 * @param realLight the realLight to set
	 */
	public void setRealLight(boolean realLight) {
		this.realLight = realLight;
	}

	/**
	 * @return the size
	 */
	public double getSize() {
		return size;
	}

	/**
	 * @param size the size to set
	 */
	public void setSize(double size) {
		if(size == -1 || size > 1)
			size= 10;
		else
			this.size = size*20;
	}
	
	
	
	

}
