/**
 * the basic graphical user interface
 */
package core;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JFileChooser;
import javax.swing.JScrollPane;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.swing.colorchooser.*;
import javax.swing.JColorChooser;
import java.awt.Color;

import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JTree;
import javax.swing.tree.TreeModel;
import javax.swing.JLabel;
import javax.swing.JSeparator;
import javax.swing.JSplitPane;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.AbstractAction;
import java.awt.event.ActionEvent;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;
import javax.swing.JButton;
import javax.swing.filechooser.FileFilter;
import objects.*;
import objects.nononjects.*;
import javax.swing.tree.DefaultMutableTreeNode;
import java.io.File;

/**
 * @see	RenderList
 * @see Rednering
 * 
 */
public class Gui2 {
	private JFrame jFrame = null; // @jve:decl-index=0:visual-constraint="109,65"
	private JPanel jContentPane = null;
	private JPanel jLeftPane = null;
	private JMenuBar jJMenuBar = null;
	private JMenu jMenu = null;
	private JSplitPane jSplitPane = null;
	private JTree jTree = null;
	private JMenuItem jMenuItem = null;
	private JMenuItem jMenuItem1 = null;
	private JMenuItem jMenuItem2 = null;
	
	private JMenuItem jMenuItem4 = null;
	private JMenuItem jMenuItem5 = null;
	private JMenuItem jMenuItem6 = null;
	private AddToRendering gfx = null;
	private JScrollPane jScrollPane = null;
	
	private JButton jButton = null;
	private AJTreeCellRenderer jTreeCellRenderer = null;
	private JMenu jMenu1 = null;
	private JMenuItem jMenuItem7 = null;
	private JMenuItem jMenuItem8 = null;
	
	private static String iconDir = System.getProperty("user.dir")+"/gfx/icons/Crystal_Office_Icons/png/png22/";
	private JMenuItem jMenuItemPlugins = null;
	private JMenuItem jMenuItemHeightmap = null;
	private JMenu jMenu2 = null;
	
	/**
	 * This is only for Eclipse IDE. Otherwise its impossible to use the 
	 * GUI editor
	 */
	public Gui2() {
	}

	/**
	 * Initialize the main User interface
	 * @param x		useless param.
	 * 
	 */
	public Gui2(int x) {
		getJFrame();
		System.out.println(iconDir);
		jFrame.show(true);
		jFrame.pack();
		final Gui2 gui = this;
		getJFrame().addWindowListener(new WindowAdapter() {
			
			public void windowClosing(WindowEvent e) {
				
				new Thread(new Runnable() {
					public void run() {
						gui.Systemexit();
					}
				}).start();
			}
		});

	}
	
	
	private void Systemexit(){
		gfx.getAnimator().stop();
		PluginManager pl = PluginManager.getInstance();
		pl.removeAll();
		System.exit(0);
	}
	
	/**
	 * This method initializes jFrame
	 * 
	 * @return javax.swing.JFrame
	 */
	private JFrame getJFrame() {
		if (jFrame == null) {
			
			jFrame = new JFrame("eTom");
			
			jFrame.setSize(new java.awt.Dimension(663, 214));
			
			jFrame.setJMenuBar(getJJMenuBar());
			jFrame.setContentPane(getJContentPane());
			
			
		}

		return jFrame;
	}
	
	/**
	 * 
	 * @return	Add to Rendering
	 */
	private AddToRendering getGfx() {
		if (gfx == null) {
			gfx = new AddToRendering();
		}
		return gfx;
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getJSplitPane(), java.awt.BorderLayout.CENTER);
			
		}
		return jContentPane;
	}

	/**
	 * This method initializes jJMenuBar
	 * 
	 * @return javax.swing.JMenuBar
	 */
	private JMenuBar getJJMenuBar() {
		if (jJMenuBar == null) {
			jJMenuBar = new JMenuBar();
			jJMenuBar.add(getJMenu());
			jJMenuBar.add(getJMenu2());
		}
		return jJMenuBar;
	}

	/**
	 * This method initializes jMenu
	 * 
	 * @return javax.swing.JMenu
	 */
	private JMenu getJMenu() {
		if (jMenu == null) {
			jMenu = new JMenu("File");
			jMenu.add(getJMenuItem());
			
			
			
			jMenu.add(getJMenuItem4());
			jMenu.add(getJMenuItem5());	
			jMenu.add(new JSeparator());
			jMenu.add(getJMenu1());
			
			jMenu.add(new JSeparator());
			jMenu.add(getJMenuItem6());

		}
		return jMenu;
	}

	/**
	 * This method initializes jSplitPane
	 * 
	 * @return javax.swing.JSplitPane
	 */
	private JSplitPane getJSplitPane() {
		if (jSplitPane == null) {
			jSplitPane = new JSplitPane();
			jLeftPane = new JPanel(new java.awt.BorderLayout());
			jScrollPane = new JScrollPane(getJTree());
			jLeftPane.add(jScrollPane, java.awt.BorderLayout.CENTER);
			jLeftPane.add(getJButton(), java.awt.BorderLayout.SOUTH);
			jSplitPane.setLeftComponent(jLeftPane);
			jSplitPane.setRightComponent(getGfx().getCanvas());
			jSplitPane.setDividerLocation(200);
		}
		
		return jSplitPane;
	}

	/**
	 * This method initializes jTree
	 * 
	 * @return javax.swing.JTree
	 */
	private JTree getJTree() {
		if (jTree == null || getGfx().getList().isRefreshJTree()) {

			if (getGfx().getList().getJTreeNode() != null){
				
					jTree = new JTree(getGfx().getList().getJTreeNode());
				
			}
			else
				jTree = new JTree();
			

		}
		setJTreeActions();
		return jTree;
	}

	
	
	private void setJTreeActions(){
		if(jTreeCellRenderer == null)
			jTreeCellRenderer = new AJTreeCellRenderer();
		jTree.setCellRenderer(jTreeCellRenderer);
		jTree.setAutoscrolls(true);
		jTree
				.addTreeExpansionListener(new javax.swing.event.TreeExpansionListener() {
					public void treeExpanded(
							javax.swing.event.TreeExpansionEvent e) {
						// jTree.clearSelection();

						System.out.println("treeExpanded()"); // TODO
						// Auto-generated
						// Event
						// stub
						// treeExpanded()
					}

					public void treeCollapsed(
							javax.swing.event.TreeExpansionEvent e) {
					}
				});
		jTree.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent e) {

				final DefaultMutableTreeNode sObject = (DefaultMutableTreeNode) jTree
						.getLastSelectedPathComponent();

				final Object selectedObject = sObject.getUserObject();
				System.out.println(selectedObject + " "
						+ selectedObject.getClass() + e);

				final DefaultMutableTreeNode par = (DefaultMutableTreeNode) sObject
				.getParent();
				
				
							
				
				if ((selectedObject instanceof objects.Structure || selectedObject instanceof objects.AtomNeighbours)
						&& e.getButton() == java.awt.event.MouseEvent.BUTTON3) {
					System.out.println("Right Strucutre");

					JPopupMenu popup = new JPopupMenu("Optionen");
					
					popup
							.add(new AbstractAction("Settings",
									new ImageIcon(
											(iconDir+"controlproperties.png"))) {
								public void actionPerformed(ActionEvent e) {
									
									if(selectedObject instanceof Structure){
										new ObjectSettings(
												(Structure) selectedObject)
												.getJFrame().setVisible(true);
									}
									if(selectedObject instanceof AtomNeighbours){
										new ObjectSettings(
												(AtomNeighbours) selectedObject)
												.getJFrame().setVisible(true);
									}
								}
							});
					
					if(selectedObject instanceof Structure){
						popup
						.add(new AbstractAction("Add Atom",
								new ImageIcon(
										iconDir+"add.png")) {
							public void actionPerformed(ActionEvent e) {
								
								if(selectedObject instanceof Structure){
									new ObjectSettings((Structure)selectedObject, true)
											.getJFrame().setVisible(true);
									
									
									
								}
								
							}
						});
						
						
						
						
						
						
						popup
						.add(new AbstractAction("Set Color",
								new ImageIcon(
										iconDir+"colors.png")) {
							public void actionPerformed(ActionEvent e) {
								Structure obj = ((Structure) selectedObject);
								Color newColor = JColorChooser.showDialog(
	                                       null,
	                                       "Selected a Color",
	                                       obj.getColor());
								if(newColor != null){
									obj.setColor(newColor);
									
									obj.reinit();
								}
							
							}
						});
						
						popup
						.add(new AbstractAction("Set Scale",
								new ImageIcon(
										iconDir+"lrarowsvg.png")) {
							public void actionPerformed(ActionEvent e) {
								Structure obj = ((Structure) selectedObject);
								Float s = Float.parseFloat((String)JOptionPane.showInputDialog(
					                    null,
					                    "Enter scale value (float with dot notation)",
					                    "Set scale of " + selectedObject,
					                    JOptionPane.PLAIN_MESSAGE
					                    ));
								if(s != null){
									obj.setScale(s);
									
									obj.reinit();
								}
							
							}
						});
						
						
						popup
						.add(new AbstractAction("Delete Mol",
								new ImageIcon(
										iconDir+"delete.png")) {
							public void actionPerformed(ActionEvent e) {
								int n = JOptionPane.showConfirmDialog(
									    null,
									    "Do you really want to delete this Molecule?",
									    "Removal of "+selectedObject,
									    JOptionPane.YES_NO_OPTION);
								if(n == 0){
									if(getGfx().getList().remove(selectedObject))
										hardRefresh();
								}
							}
						});
						
						popup
						.add(new AbstractAction("Search Neighbours",
								new ImageIcon(
										iconDir+"bullet.png")) {
							public void actionPerformed(ActionEvent e) {
								
								if(selectedObject instanceof Structure){
									((Structure)selectedObject).autoCompletNextNeighbours();
											
									
									
									
								}
								
							}
						});
						
						
						
					}
					
					if(selectedObject instanceof Atom){
						popup
						.add(new AbstractAction("Delete Atom",
								new ImageIcon(
										iconDir+"delete.png")) {
							public void actionPerformed(ActionEvent e) {
								
								if(par.getUserObject() instanceof Structure){
									int n = JOptionPane.showConfirmDialog(
										    null,
										    "Do you really want to remove "+par+"?",
										    "Removal of "+par+ " from "+selectedObject,
										    JOptionPane.YES_NO_OPTION);
									if(n == 0){
										Structure s = ((Structure) par.getUserObject());
										if(s.getAtome().remove((AtomNeighbours) selectedObject)){
											JOptionPane.showMessageDialog(null,
												    "Atom has been removed!",
												    "Atom has been removed",
												    JOptionPane.INFORMATION_MESSAGE);
											s.reinit();
										} else {
											JOptionPane.showMessageDialog(null,
												    "Failed to remove atom!",
												    "Failed to remove",
												    JOptionPane.ERROR_MESSAGE);
										}
									}
									
									
									
									
								}
								
							}
						});
					}
					
					
					
					
				
					
					
					
					
					
					
					
					
					popup.show(e.getComponent(), e.getX(), e.getY());
					//popup.setVisible(true);
					// Rechte Maustaste auf Structure oder Atom
				}

				if (selectedObject instanceof objects.Atom) {
					
					if (par.getUserObject() instanceof objects.Structure) {
						Structure str = (Structure) par.getUserObject();
						AtomNeighbours a = (AtomNeighbours) selectedObject;
						System.out.println("aaatom");
						a.setSelected(!a.isSelected());
						str.reinit();
					}

					// atom
				}

				if (selectedObject instanceof objects.nononjects.WechselWirkung && e.getButton() == java.awt.event.MouseEvent.BUTTON3) {
					
					
					
					JPopupMenu popup = new JPopupMenu("Optionen");
					
					
					
					popup
					.add(new AbstractAction("Select all",
							new ImageIcon( 
									iconDir+"plus.png")) {
						public void actionPerformed(ActionEvent e) {
								
							getGfx().getList().setSelectedByWW((WechselWirkung) selectedObject, true);
							
						}
					});
					
					
					popup
					.add(new AbstractAction("Unselect all",
							new ImageIcon( 
									iconDir+"rminus.png")) {
						public void actionPerformed(ActionEvent e) {

							
							getGfx().getList().setSelectedByWW((WechselWirkung) selectedObject, false);
						
							
							
						}
					});
			
			
					
					
					
						
					
					
					
					
					
					
					
					
					popup
							.add(new AbstractAction("Change Exchange Interaction",
									new ImageIcon( 
											iconDir+"pencil.png")) {
								public void actionPerformed(ActionEvent e) {
									WechselWirkung ww = (WechselWirkung) selectedObject;
									String s = (String)JOptionPane.showInputDialog(
						                    null,
						                    "Exchange Interaction Value :\n"
						                    ,
						                    "Change Exchange Interaction",
						                    JOptionPane.PLAIN_MESSAGE
						                    );
									if(s != null)
										ww.setValue(Float.parseFloat(s));
									
								}
							});
					
					
					popup.show(e.getComponent(), e.getX(), e.getY());
					// wechselwirkung
				}
				
			}
		});
	}
	
	
	
	
	/**
	 * This method initializes jMenuItem
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItem() {
		if (jMenuItem == null) {
			jMenuItem = new JMenuItem("New Project");
			jMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					getGfx().getList().clear();
					objects.WWManager ww = objects.WWManager.getInstance();
					ww.clear();
					hardRefresh();
				}
			});
		}
		return jMenuItem;
	}

	/**
	 * This method initializes jMenuItem1
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItem1() {
		if (jMenuItem1 == null) {
			jMenuItem1 = new JMenuItem("Dodekaedron");
			jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					getGfx().addDode();
					// getGfx().addBuckyBall();
					getGfx().getList().refreshJTree();
					hardRefresh();
					System.out.println("actionPerformed()"); // TODO
					
				}
			});
		}
		return jMenuItem1;
	}

	/**
	 * This method initializes jMenuItem2
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItem2() {
		if (jMenuItem2 == null) {
			jMenuItem2 = new JMenuItem("New Surface");
			jMenuItem2.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					
					
					Integer x = Integer.parseInt((String)JOptionPane.showInputDialog(
		                    null,
		                    "Describe the surface:\n"
		                    + "\"width\"",
		                    "Description of surface",
		                    JOptionPane.PLAIN_MESSAGE,
		                    null, null, null));
					
					
					
					Integer z = Integer.parseInt((String)JOptionPane.showInputDialog(
		                    null,
		                    "Describe the surface:\n"
		                    + "\"length\"",
		                    "Description of surface",
		                    JOptionPane.PLAIN_MESSAGE,
		                    null, null, null));
					
					Integer y = Integer.parseInt((String)JOptionPane.showInputDialog(
		                    null,
		                    "Describe the surface:\n"
		                    + "\"height\"",
		                    "Description of surface",
		                    JOptionPane.PLAIN_MESSAGE,
		                    null, null, null));
					
					getGfx().addSurface(x,y,z);
					
					getGfx().getList().refreshJTree();
					hardRefresh();
					System.out.println("new surface()"); // TODO
					// Auto-generated
					// Event stub
					// actionPerformed()
				}
			});
		}
		return jMenuItem2;
	}

	/**
	 * This method initializes jMenuItem3
	 * 
	 * @return javax.swing.JMenuItem
	 */
	/*private JMenuItem getJMenuItem3() {
		if (jMenuItem3 == null) {
			jMenuItem3 = new JMenuItem("Import");
			jMenuItem3.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					getGfx().addFilePDB();
					getGfx().getList().refreshJTree();
					System.out.println("actionPerformed()"); // TODO
					// Auto-generated
					// Event stub
					// actionPerformed()
				}
			});
		}
		return jMenuItem3;
	}*/

	/**
	 * This method initializes jMenuItem4
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItem4() {
		if (jMenuItem4 == null) {
			jMenuItem4 = new JMenuItem("Open Project");
			jMenuItem4.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					JFileChooser fc = new JFileChooser();
					fc.addChoosableFileFilter(new FileFilter() {
						public boolean accept(File f) {
                            if (f.isDirectory()) return true;
                            return f.getName().toLowerCase().endsWith(".sml");
                          }
						public String getDescription () { return "Spin Molecule Language (SML)"; }
					});
					fc.setAcceptAllFileFilterUsed(false);
					
					int fileset = fc.showOpenDialog(getJContentPane().getComponent(0));
					if(fileset == 0 ){
						System.out.println(fc.getSelectedFile());
						getGfx().getList().clear();
						getGfx().addFileXML(fc.getSelectedFile().toString());
						
					}
					hardRefresh();
				}
				
			});
		}
		return jMenuItem4;
	}

	
	
	
	
	/**
	 * This method initializes jMenuItem5
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItem5() {
		if (jMenuItem5 == null) {
			jMenuItem5 = new JMenuItem("Save Project");
			jMenuItem5.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					// TODO this worked befor
					/*System.out.println(getGfx().list.toXML());
					System.out.println(getGfx().list.getNN());
					System.out.println("-----------");
					System.out.println(getGfx().list.getJJ());
					System.out.println("-----------");
					System.out.println(getGfx().list.getWW());
					*/
					JFileChooser fc = new JFileChooser();
					
					
					
					int returnVal = fc.showSaveDialog(getJContentPane().getComponent(0));

			        if (returnVal == JFileChooser.APPROVE_OPTION) {
			        	System.out.println("schreibe datei");
			        	File file = fc.getSelectedFile();
			            File fileww = new File(file+".ww");
			            File filenn = new File(file+".nn");
			            File filejj = new File(file+".jj");
			            File filesml = new File(file+".sml");
			            
			            FileIO fileio = new FileIO(file, getGfx().list.getWW());
			            file.renameTo(fileww);
			            fileio.write();
			            
			            
			            fileio = new FileIO(file, getGfx().list.getNN());
			            file.renameTo(filenn);
			            fileio.write();
			            
			            fileio = new FileIO(file, getGfx().list.getJJ());
			            file.renameTo(filejj);
			            fileio.write();
			            
			            fileio = new FileIO(file, getGfx().list.toXML());
			            file.renameTo(filesml);
			            fileio.write();
			            
			            //System.out.println(file);
			            //This is where a real application would open the file.
			           
			        } else {
			           
			        }
					
				}
			});
		}
		return jMenuItem5;
	}

	/**
	 * This method initializes jMenuItem6
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItem6() {
		final Gui2 gui = this;
		if (jMenuItem6 == null) {
			jMenuItem6 = new JMenuItem("Exit");
			jMenuItem6.addActionListener(new java.awt.event.ActionListener() {
//				final RenderList slist = ;
				public void actionPerformed(java.awt.event.ActionEvent e) {
					int n = JOptionPane.showConfirmDialog(
						    null,
						    "Exit?",
						    "Exit",
						    JOptionPane.YES_NO_OPTION);
					if(n==0){
						
						gui.Systemexit();
					}
					//	System.exit(0);
				}
				
			});
		}
		return jMenuItem6;
	}
	
	/**
	 * 
	 * @return {@link JButton}
	 */
	private JButton getJButton(){
		if(jButton == null)
			jButton = new JButton("Refresh");
			jButton.addActionListener(new java.awt.event.ActionListener() {
//				final RenderList slist = ;
				public void actionPerformed(java.awt.event.ActionEvent e) {
					
					
					
					hardRefresh();
					
				}
			});
			
		return jButton;
	}

	/**
	 * 
	 *Initial refresh of the JTree. Therefor a totally new JTree will be generated
	 */
	private void hardRefresh(){

		/*
		 * 
		 * This code is BShit.
		 * 
		 * But it generates the Tree totally new
		 * 
		 */
		
		jTree = new JTree(getGfx().list.refreshJTree());
		
		jLeftPane.remove(jScrollPane);
		
		jScrollPane = new JScrollPane(jTree);
		
		setJTreeActions();
		
		jLeftPane.add(jScrollPane, java.awt.BorderLayout.CENTER);
		
		jLeftPane.repaint();
		
		
		jTree.repaint();
		Dimension s = getJFrame().getSize();
		getJFrame().pack();
		jSplitPane.setDividerLocation(200);
		getJFrame().setSize(s);
		
		
		
		
		
	}
	
	
	/**
	 * This method initializes jMenu1	
	 * 	
	 * @return javax.swing.JMenu	
	 */
	private JMenu getJMenu1() {
		if (jMenu1 == null) {
			jMenu1 = new JMenu("Extend ...");
			jMenu1.add(getJMenuItem7());
			jMenu1.addSeparator();
			//surface
			jMenu1.add(getJMenuItem2());
			jMenu1.add(getJMenuItem1());
			
			
			jMenu1.add(getJMenuItem8());
		}
		return jMenu1;
	}

	/**
	 * This method initializes jMenuItem7	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getJMenuItem7() {
		if (jMenuItem7 == null) {
			jMenuItem7 = new JMenuItem("Import File");
			jMenuItem7.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					JFileChooser fc = new JFileChooser();
					fc.addChoosableFileFilter(new FileFilter() {
						public boolean accept(File f) {
                            if (f.isDirectory()) return true;
                            String files = f.getName().toLowerCase();
                            if(
                            		files.endsWith(".sml") ||
                            		files.endsWith(".saf") || 
                            		files.endsWith(".pdb")
                            		)
                            		return true;
                            else return false;
                          }
						public String getDescription () { return "Any"; }
					});
					
					fc.addChoosableFileFilter(new FileFilter() {
						public boolean accept(File f) {
                            if (f.isDirectory()) return true;
                            String files = f.getName().toLowerCase();
                            if(
                            		files.endsWith(".sml") 
                            		
                            		
                            		)
                            		return true;
                            else return false;
                          }
						public String getDescription () { return "SML"; }
					});
					
					fc.addChoosableFileFilter(new FileFilter() {
						public boolean accept(File f) {
                            if (f.isDirectory()) return true;
                            String files = f.getName().toLowerCase();
                            if(
                            		files.endsWith(".saf") 
                            		
                            		
                            		)
                            		return true;
                            else return false;
                          }
						public String getDescription () { return "SAF"; }
					});
					
					fc.addChoosableFileFilter(new FileFilter() {
						public boolean accept(File f) {
                            if (f.isDirectory()) return true;
                            String files = f.getName().toLowerCase();
                            if(
                            		files.endsWith(".pdb") 
                            		
                            		
                            		)
                            		return true;
                            else return false;
                          }
						public String getDescription () { return "PDB"; }
					});
					
					
					
					fc.setAcceptAllFileFilterUsed(false);
					
					int fileset = fc.showOpenDialog(getJContentPane().getComponent(0));
					if(fileset == 0 ){
						System.out.println(fc.getSelectedFile());
						String file = fc.getSelectedFile().toString();
						String sfile = fc.getSelectedFile().toString().toLowerCase();
						if(sfile.endsWith(".sml"))
							getGfx().addFileXML(file);
						else if (sfile.endsWith(".pdb"))
							getGfx().addFilePDB(file);
						else if (sfile.endsWith(".saf"))
							getGfx().addFileASCII(file);
						
					}
					
				}
			});
		}
		return jMenuItem7;
	}

	/**
	 * This method initializes jMenuItem8	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getJMenuItem8() {
		if (jMenuItem8 == null) {
			jMenuItem8 = new JMenuItem("BuckyBall");
			jMenuItem8.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					getGfx().addBuckyBall();
					hardRefresh();
				}
			
			});
		}
		return jMenuItem8;
	}

	/**
	 * This method initializes jMenuItem3	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getJMenuItemPlugins() {
		if (jMenuItemPlugins == null) {
			jMenuItemPlugins = new JMenuItem("Plugins");
			jMenuItemPlugins.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					PluginManager.getInstance().add(PluginWii.class);
					refreshPlugins();
				}
			});
		}
		return jMenuItemPlugins;
	}

	/**
	 * This method initializes jMenu2	
	 * 	
	 * @return javax.swing.JMenu	
	 */
	private JMenu getJMenu2() {
		if (jMenu2 == null) {
			jMenu2 = new JMenu("Tools");
			jMenu2.add(getJMenuItemPlugins());
			jMenu2.add(getJMenuItemHeightmap());
			refreshPlugins();
			
		}
		return jMenu2;
	}

	
	private void refreshPlugins(){
		if(PluginManager.getInstance().size() > 0){
			JPopupMenu disconnect = new JPopupMenu("Disconnect");
			for(Class c : PluginManager.getInstance().getList()){
				disconnect.add(new JMenuItem(c.toString()));
			}
			jMenu2.add(disconnect);
			jMenu2.repaint();
		}
	}

	/**
	 * This method initializes jMenuItem3	
	 * 	
	 * @return javax.swing.JMenuItemHeightmap	
	 */
	private JMenuItem getJMenuItemHeightmap() {
		if (jMenuItemHeightmap == null) {
			jMenuItemHeightmap = new JMenuItem("Heightmap");
			jMenuItemHeightmap.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					getGfx().addFileTGA();
				}
			});
		}
		return jMenuItemHeightmap;
	}
}
