/**
 * 
 */

package core;

import java.util.ArrayList;

import objects.WWManager;
/**
 * @author tekkno
 *
 */
public class PluginManager {
	 /** Privates Klassenattribut, einzige Instanz der Klasse wird erzeugt. */
    private static final PluginManager INSTANCE = new PluginManager();
	
	private static ArrayList<Class> plugins;
	private static ArrayList<Object> objs;
	
	/**
	 * 
	 */
	
	private PluginManager() {
		plugins = new ArrayList<Class>();
		objs = new ArrayList<Object>();
	}
	
	public static PluginManager getInstance() {
        return INSTANCE;
    }
	
	public void add(Class classname){
		boolean success = true;
		if(classname.equals(PluginWii.class)){
			PluginWii wii = new PluginWii();
			if(!wii.isConnected())
				wii = null;
			if(wii!= null)
				objs.add(wii);
		}
		if(success)
			plugins.add(classname);
		else
			System.err.println("Einfügen des Plugins Fehlgeschlagen! "+classname);
	}
	
	private int getPossition(Class classname){
		 return plugins.indexOf(classname);
	}
	
	public Position3D getObj(Class classname){
		int pos = getPossition(classname);
		if(objs.size() > 0 && pos > -1){
			Position3D posObj = (Position3D) objs.get(pos);
			if(posObj != null)
				return posObj;
		}
		return null;
	}
	
	public void remove(Class classname){
		int pos = getPossition(classname);
		if(pos != -1 && objs.size() > 0){
			plugins.remove(pos);
			Position3D workingOn = ((Position3D)objs.get(pos));
			if(workingOn != null){
				workingOn.close();
				objs.remove(pos);
			}
		} else {
			System.err.println("unknown plugin: " + classname +
					"\nSize of Pluginlist: " + objs.size());
		}
	}
	
	public int size(){
		return objs.size();
	}
	
	public ArrayList<Class> getList(){
		return  plugins;
	}
	
	public void removeAll(){
		ArrayList<Class> buf = new ArrayList<Class>();
		for(Class c : plugins){
			buf.add(c);
		}
		for (Class c: buf)
			remove(c);
	}

}
