/**
 * the Core Rendering which contains some extra functions which should be seperated into different classes in a futher step
 * its seperated into parts which features different tasks.
 * The Main Renderingloop and the 3D Pointing algorithm are the most important points in
 * this Class.
 * 
 * its Basicly a JOGL based Canvas
 */
package core;

import java.awt.*;
import java.awt.event.*;

import javax.media.opengl.*;
import javax.media.opengl.glu.*;
import javax.swing.AbstractAction;
import javax.swing.ImageIcon;
import javax.swing.JPopupMenu;
import javax.swing.JOptionPane;


import com.sun.opengl.util.*;

import objects.*;
import objects.nononjects.*;

import java.util.Stack;
import java.nio.*;
import com.sun.opengl.util.texture.*;
import java.io.*;
import java.util.Date;

import java.util.ArrayList;




public class Rendering extends Component implements GLEventListener,
		MouseListener, MouseWheelListener, MouseMotionListener {
	GLCanvas canvas;
	FPSAnimator animator;
	private Texture texture;
	private Point pickPoint = new Point();
	private static final int BUFSIZE = 512;
	protected float camdist = 0.0f;
	//startup Background if nothing else is defined
	static float background[] = { 0.59f, 0.59f, 0.59f, 0.0f };
	private MouseEvent mouse = null;
	
	private static String userDir = System.getProperty("user.dir");
	private static String iconDir = userDir+"/gfx/icons/Crystal_Office_Icons/png/png22/";
	private static PluginManager pluginManager;
	
	/*
	 * 
	 * Plugin vars
	 * 
	 */
	
	double lastPos[];
	
	/**
	 * Init the Canvas and stats the FPS Animator
	 * Main Constructor
	 */
	public Rendering() {
		
		if (canvas == null) {
			//Frame frame = new Frame("jamView");

			canvas = new GLCanvas();
			canvas.addGLEventListener(this);
			
			/*pluginManager = PluginManager.getInstance();
			pluginManager.add(PluginWii.class);*/
			
			list = new RenderList<Structure>();
			getAnimator();
			
			/*frame.addWindowListener(new WindowAdapter() {

				public void windowClosing(WindowEvent e) {
					// Run this on another thread than the AWT event queue to
					// make sure the call to Animator.stop() completes before
					// exiting
					new Thread(new Runnable() {
						public void run() {
							animator.stop();
							System.exit(0);
						}
					}).start();
				}
			});
			*/
			animator.start();

		}

	}

	
	/**
	 * 
	 * @return	java
	 */
	public FPSAnimator getAnimator() {
		if(animator == null){
			animator = new FPSAnimator(canvas, 125);
			animator.setRunAsFastAsPossible(false);
		}
		return animator;
	}

	private float view_rotx = 0.0f, view_roty = 0.0f, view_rotz = 0.0f;

	

	private float angle = 0.0f;

	private int prevMouseX, prevMouseY;

	private boolean mouseRButtonDown = false;

	protected RenderList<Structure> list;

	/**
	 * Returns the core GLCanvas
	 * @see 	GLCanvas
	 * @return	GLCanvas
	 */
	public GLCanvas getCanvas() {
		return canvas;
	}

	
	/**
	 * Setup up the basic GL parameters like Position and Rendermods
	 * for Developers there are some example Arrays in this construct to
	 * test different Colors
	 * @param	drawable	the GL Context
	 */
	public void init(GLAutoDrawable drawable) {
		// Use debug pipeline
		drawable.setGL(new DebugGL(drawable.getGL()));

		GL gl = drawable.getGL();

		System.err.println("INIT GL IS: " + gl.getClass().getName());

		System.err.println("Chosen GLCapabilities: "
				+ drawable.getChosenGLCapabilities());

		gl.setSwapInterval(1);

		float pos[] = { 5.0f, 5.0f, 10.0f, 0.0f };
		float red[] = { 0.8f, 0.1f, 0.0f, 1.0f };
		float green[] = { 0.0f, 0.8f, 0.2f, 1.0f };
		float blue[] = { 0.2f, 0.2f, 1.0f, 1.0f };

		gl.glLightfv(GL.GL_LIGHT0, GL.GL_POSITION, pos, 0);
		gl.glEnable(GL.GL_CULL_FACE);
		gl.glEnable(GL.GL_LIGHTING);
		gl.glEnable(GL.GL_LIGHT0);
		gl.glEnable(GL.GL_DEPTH_TEST);

		

		gl.glEnable(GL.GL_NORMALIZE);

		drawable.addMouseListener(this);
		drawable.addMouseMotionListener(this);
		drawable.addMouseWheelListener(this);
		
		texture = (new TextureLoader()).load(userDir+"/gfx/lightning3.png");

	}

	/**
	 * Reshape function for window resize. This needs to be implemented by interface
	 * Setting addictional settings for Renderingmode
	 * @see core.Rendering#init()
	 * @see javax.media.opengl.GLEventListener#reshape(javax.media.opengl.GLAutoDrawable, int, int, int, int)
	 */
	public void reshape(GLAutoDrawable drawable, int x, int y, int width,
			int height) {
		GL gl = drawable.getGL();

		float h = (float) height / (float) width;

		gl.glMatrixMode(GL.GL_PROJECTION);

		System.err.println("GL_VENDOR: " + gl.glGetString(GL.GL_VENDOR));
		System.err.println("GL_RENDERER: " + gl.glGetString(GL.GL_RENDERER));
		System.err.println("GL_VERSION: " + gl.glGetString(GL.GL_VERSION));
		gl.glLoadIdentity();
		gl.glFrustum(-1.0f, 1.0f, -h, h, 5.0f, 2000.0f);
		gl.glMatrixMode(GL.GL_MODELVIEW);
		gl.glLoadIdentity();
		gl.glTranslatef(0.0f, 0.0f, -200 + camdist);

	}

	/**
	 * Main Rendering Loop
	 * @see javax.media.opengl.GLEventListener#display(javax.media.opengl.GLAutoDrawable)
	 */
	public void display(GLAutoDrawable drawable) {

		// Get the GL corresponding to the drawable we are animating
		GL gl = drawable.getGL();

		gl.glMatrixMode(GL.GL_MODELVIEW);
		
		//cam Movement
		if (camdist > 0.000001 || camdist < -0.000001)
			camdist = (float) camdist / 1.1f;
		else
			camdist = 0.0f;
		gl.glTranslatef(0.0f, 0.0f, camdist);

		// Special handling for the case where the GLJPanel is translucent
		// and wants to be composited with other Java 2D content
		if ((drawable instanceof GLJPanel)
				&& !((GLJPanel) drawable).isOpaque()
				&& ((GLJPanel) drawable)
						.shouldPreserveColorBufferIfTranslucent()) {
			gl.glClear(GL.GL_DEPTH_BUFFER_BIT);
		} else {
			gl.glClear(GL.GL_COLOR_BUFFER_BIT | GL.GL_DEPTH_BUFFER_BIT);
		}

		// sky background
		gl.glClearColor(background[0], background[1], background[2],
				background[3]);

		// Rotate the entire assembly whenever user
		// dragged the mouse around
		gl.glPushMatrix();
		gl.glRotatef(view_rotx, 1.0f, 0.0f, 0.0f);
		gl.glRotatef(view_roty, 0.0f, 1.0f, 0.0f);
		gl.glRotatef(view_rotz, 0.0f, 0.0f, 1.0f);

		
		
		gl.glPushMatrix();
		
		gl.glRotatef(-2.0f * angle - 9.0f, 0.0f, 0.0f, 1.0f);
		
		
		
		gl.glPopMatrix();
		
		/*
		 * 
		 * Plugin Part
		 * 
		 */
		
		Position3D wii = pluginManager.getInstance().getObj(PluginWii.class);
		if(wii != null){
			gl.glTranslated
				(wii.getPossition()[0], wii.getPossition()[1], wii.getPossition()[2]);
			//camdist += wii.getPossition()[2];
			if (lastPos != wii.getPossition()){
				System.out.print("Wiiiiii: "+wii.getPossition()[0]+" "+wii.getPossition()[1]);
				lastPos = wii.getPossition();
			}
		}
		
		/**
		 * most important function is the basic call of the RenderList
		 * All Objects need to be stored there
		 * @see RenderList
		 */
		for (Structure obj : list) {
			if(obj != null)
				obj.draw();
		}

		/*
		 * 
		 * mouse clicking handling
		 * 
		 */
		if (mouse != null) {
			getClickCords(drawable);
			list.refreshJTree();
			
			mouse = null;
		}

		TextureCoords tc = texture.getImageTexCoords();

		texture.enable();
		//gl.glDisable(GL.GL_TEXTURE_RECTANGLE_ARB);
		
		
		/*
		 * TODO this needs to be reworks. Until now it draws the connections just be the
		 * order in the "list". Need to be the sortest connection to next atom
		 * This part is vor generating the connections (Flash) between every atom
		 */
		
		//Aditive color system to get some "bling bling" into it
		gl.glBlendFunc(GL.GL_SRC_ALPHA, GL.GL_ONE_MINUS_SRC_ALPHA);
		gl.glBlendFunc(GL.GL_SRC_ALPHA, GL.GL_ONE);
		gl.glEnable(GL.GL_BLEND);

		gl.glDisable(GL.GL_CULL_FACE);

		gl.glHint(GL.GL_PERSPECTIVE_CORRECTION_HINT, GL.GL_NICEST);
		gl.glTexParameteri(GL.GL_TEXTURE_2D, GL.GL_TEXTURE_MAG_FILTER,
				GL.GL_LINEAR);
		gl
				.glTexParameteri(GL.GL_TEXTURE_2D, GL.GL_TEXTURE_WRAP_S,
						GL.GL_REPEAT);
		gl
				.glTexParameteri(GL.GL_TEXTURE_2D, GL.GL_TEXTURE_WRAP_T,
						GL.GL_REPEAT);

		texture.bind();
		

		gl.glDisable(GL.GL_LIGHTING);
		
		gl.glColor4f(0.5f, .5f, 1.0f, 1f);
		gl.glEnable(GL.GL_TEXTURE_2D);

		gl.glBegin(GL.GL_QUAD_STRIP);

		int object = 1;
		for (Structure obj : list) {
			if(obj != null)
			for (AtomNeighbours atom : obj.getAtome()) {
				

				if (atom != null)
					if (atom.isSelected()) {
						
						float ran = (new Date()).getTime() % 500;
						ran = ran / 500f + (float) Math.random() / 6f;
						
						if (object % 2 == 0)
							gl.glTexCoord2f(tc.left() + ran, tc.top() / 2);
						else
							gl.glTexCoord2f(tc.right() + ran, tc.top() / 2);
						
						gl.glVertex3d(atom.getX()*obj.getScale() + obj.getX()*obj.getScale()*obj.getScale(), atom.getY() * obj.getScale()
								+ obj.getY()*obj.getScale() + 0.5, atom.getZ()*obj.getScale() + obj.getZ()*obj.getScale());
						
						if (object % 2 == 0)
							gl.glTexCoord2f(tc.left() + ran, tc.bottom());

						else
							gl.glTexCoord2f(tc.right() + ran, tc.bottom());

						gl.glVertex3d(atom.getX() * obj.getScale() + obj.getX() *obj.getScale(), atom.getY()*obj.getScale()
								+ obj.getY()*obj.getScale() - 0.5, atom.getZ()*obj.getScale() + obj.getZ()*obj.getScale());

						object++;

					}

			}
		}

		gl.glEnd();

		
		//call the next Neighbours method
		drawNN(drawable);

		// end of draw
		gl.glPopMatrix();

		
		//disable all Bling bling parts
		//gl.glDisable(GL.GL_TEXTURE_RECTANGLE_ARB);
		gl.glBindTexture(texture.getTarget(), texture.getTextureObject());

		gl.glEnable(GL.GL_LIGHTING);
		gl.glEnable(GL.GL_LIGHT0);
		gl.glDisable(GL.GL_TEXTURE_2D);
		
		gl.glEnable(GL.GL_CULL_FACE);
		
		gl.glDisable(GL.GL_BLEND);
		gl.glEnable(GL.GL_DEPTH_TEST);

		texture.disable();
	}

	/**
	 * This method draws the next neighbours.
	 * All informations for neighbours need to be stored in the List of "objects"
	 * @see RenderList
	 * @param drawable	GL Context to draw in
	 */
	private void drawNN(GLAutoDrawable drawable) {
		GL gl = drawable.getGL();
		GLU glu = new GLU();
		int glListed;

		//generate a new object for less cpu cycles
		glListed = gl.glGenLists(1);
		gl.glNewList(glListed, GL.GL_COMPILE);
			GLUquadric qobj0 = glu.gluNewQuadric();
			glu.gluQuadricTexture(qobj0, true);
	
			glu.gluQuadricDrawStyle(qobj0, GLU.GLU_FILL);
			glu.gluQuadricNormals(qobj0, GLU.GLU_SMOOTH);
			glu.gluSphere(qobj0, 0.5f, 10, 10);

		gl.glEndList();

		Stack<AtomNeighbours> draw = new Stack<AtomNeighbours>();

		for (Structure obj : list) {
			if(obj != null)
			for (AtomNeighbours a : obj.getAtome()) {
				if (a.isSelected())
					draw.addAll(a.getNeighbours());
			}
		}

		if (!draw.isEmpty()) {
			float ran = ((new Date()).getTime() / 2) % 360;
			int no = 0;

			for (Structure obj : list) {

				gl.glPushMatrix();

				gl.glTranslated(obj.getX(), obj.getY(), obj.getZ());

				for (Atom a : obj.getAtome()) {
					no += 10;
					if (draw.contains(a)) {
						gl.glPushMatrix();
						a.getWorldCords();
						
						// TODO this doesn work :/ 
						/*
						 * to make it more easy to draw this items it would be good to use the 
						 * wordcoords instead of rebuilding the position
						 */
						// gl.glTranslated(a.wcoord[0], a.wcoord[1],
						// a.wcoord[2]);
						gl.glTranslated(+a.getX()*obj.getScale(), a.getY()*obj.getScale(), a.getZ()*obj.getScale());

						
						gl.glRotated(ran, 1, 0, 0);
						

						gl.glCallList(glListed);
					
						gl.glPopMatrix();
					}

				}

				gl.glPopMatrix();
			}
		}

		//free the list of unused objects
		gl.glDeleteLists(glListed, 1);
	}
	
	/**
	 * Calls the recuHit to find the next Objects. 
	 * This method get the last Clickevent (in this canvas) and calculates the matching atoms
	 * The "Frustrum" get broaden whenever you click a atom which is far away. So its easier to
	 * click a atom which is far away. This causes the system to "prior" atoms which are far away.
	 * We tried to prevent the system to select all atoms which are in one line but the prior of deep 
	 * elements work against this.
	 * 
	 * In addional the Clickevents are stored in this function too (cause we need to know how many items 
	 * got selected).
	 * 
	 * @param 	drawable	GL Context to draw in
	 * @return 	unused until now. 
	 */
	private float[] getClickCords(GLAutoDrawable drawable) {
		GL gl = drawable.getGL();

		int viewport[] = new int[4];
		double mvmatrix[] = new double[16];
		double projmatrix[] = new double[16];



		int realy = 0;
		int x = mouse.getX(), y = mouse.getY();

		gl.glGetIntegerv(GL.GL_VIEWPORT, viewport, 0);
		gl.glGetDoublev(GL.GL_MODELVIEW_MATRIX, mvmatrix, 0);
		gl.glGetDoublev(GL.GL_PROJECTION_MATRIX, projmatrix, 0);
		/* note viewport[3] is height of window in pixels */
		realy = viewport[3] - (int) y - 1;
		System.out.println("Coordinates at cursor are (" + x + ", " + realy);
		Stack<AtomNeighbours> foundA = new Stack<AtomNeighbours>();

		
		
		
		Stack<AtomNeighbours> selectedAtoms = new Stack<AtomNeighbours>();
		AtomNeighbours selectedA = null;
		Structure lastS = null;
		int selected = 0;
		for (Structure obj : list) {
			if(obj!=null)
			for (AtomNeighbours a : obj.getAtome()) {
				if(a != null)
				if (a.isSelected()) {
					selectedAtoms.add(a);
					selected++;
					selectedA = a;
					lastS = obj;
				}
			}
		}

		
		double lowestDist = 0.0d;
		
		foundA.clear();
		for (Structure obj : list) {
			if(obj!= null){
				gl.glPushMatrix();
				obj.translate(gl);
	
				
				
				
				for (AtomNeighbours a : obj.getAtome()) {
					double ac[] = a.getWorldCords(obj.getScale());
					double dist = (ac[0]*ac[0]+ac[1]*ac[1]+ac[2]*ac[2]);
					if(dist > lowestDist){
						
						if (recuHit(ac, x, realy, 1)) {
							foundA.add(a);
							lowestDist = dist;
							//TODO filtern
							
						}
					}
	
				}
				if (!foundA.isEmpty()){
					AtomNeighbours buf = foundA.lastElement();
					foundA.clear();
					foundA.add(buf);
					obj.reinit();
					
				}
				gl.glPopMatrix();
			}

		}
		switch (mouse.getButton()) {
		case MouseEvent.BUTTON1:

			for (Atom atom : foundA) {
				atom.setSelected(!atom.isSelected());
			}
			break;
		case MouseEvent.BUTTON3:

			JPopupMenu popup = new JPopupMenu("Optionen");

			if (foundA.size() == 1) {
				final AtomNeighbours aToRemove = foundA.get(0);
				final Structure struct = lastS;

				popup.add(new AbstractAction("Settings", new ImageIcon(
						 iconDir+"controlproperties.png")) {

					public void actionPerformed(ActionEvent e) {
						ObjectSettings set = (new ObjectSettings(struct,
								aToRemove));
						set.getJFrame().setVisible(true);

					}
				});

				popup.add(new AbstractAction("Delete Atom", new ImageIcon(
						iconDir+"delete.png")) {

					public void actionPerformed(ActionEvent e) {
						struct.getAtome().remove(aToRemove);
						struct.reinit();
					}
				});
			}

			if (selected == 2) {
				final AtomNeighbours n1 = selectedAtoms.get(0);
				final AtomNeighbours n2 = selectedAtoms.get(1);
				if(WWManager.getInstance().getWW().size() > 0){
					popup.add(new AbstractAction("Define Exchange Interaction",
							new ImageIcon( 
									iconDir+"bezierinsertn.png")) {
						
						public void actionPerformed(ActionEvent e) {
							WWManager wwman = WWManager.getInstance();
							
							
							//Stack<WechselWirkung> ww = new Stack<WechselWirkung>();
							
							
							//ww.addAll();
							
							
							
							Object[] possibilities = wwman.getWW().toArray();
							
								WechselWirkung s = (WechselWirkung)JOptionPane.showInputDialog(
								                    null,
								                    "select Exchange Interaction:\n",						                 
								                    "Exchange Interaction",
								                    JOptionPane.YES_NO_CANCEL_OPTION,
								                    
								                    null,
								                    possibilities,
								                    possibilities[0]);					
								
								if(s != null){
									n1.setNeighbours(n2);
									n2.setNeighbours(n1);
									
									
									n1.setNeighbourJJ(n2, s.getIdentifier());
									n2.setNeighbourJJ(n1, s.getIdentifier());
									
									wwman.addJJ(s.getIdentifier(), n2);
									wwman.addJJ(s.getIdentifier(), n1);
									
								}
							
							
							
							list.setRefreshJTree(true);
							
							
							
							System.out.println(n1.getNeighbourJJ(n2));
						}
					});
					
				//ende keine Wechselwirkung vorhanden	
				}
				
				
				
				popup.add(new AbstractAction("New Exchange Interaction",
				
						new ImageIcon( 
								iconDir+"bezierappend.png")) {
					public void actionPerformed(ActionEvent e) {
						Float x = Float.parseFloat((String)JOptionPane.showInputDialog(
			                    null,
			                    "Define a new Exchange Interaction Value:\n"
			                    ,
			                    "New Exchange Interaction Value",
			                    JOptionPane.PLAIN_MESSAGE,
			                    null, null, null));
						Stack<WechselWirkung> ww = new Stack<WechselWirkung>();
						
						WWManager wwman = WWManager.getInstance();
						wwman.setWW(wwman.getWW().size()+1, x);
						
						n1.setNeighbours(n2);
						n2.setNeighbours(n1);
								
						 
						n1.setNeighbourJJ(n2, wwman.getWW().size());
						n2.setNeighbourJJ(n1, wwman.getWW().size());
						
						wwman.addJJ(wwman.getWW().size(), n2);
						wwman.addJJ(wwman.getWW().size(), n1);
						
						
						
					}
				});
				
				
			} else
				System.out.println("selected = " + selected);
			
			

			if (foundA.size() == 1 && selected == 1) {
				final AtomNeighbours newNeigh = foundA.get(0);
				final AtomNeighbours target = selectedA;

				if (target.getNeighbours().contains(newNeigh)) {
					popup.add(new AbstractAction("Release neighbourhood",
							new ImageIcon(
									iconDir+"unchainframes.png")) {
						public void actionPerformed(ActionEvent e) {
							target.getNeighbours().remove(newNeigh);
							newNeigh.getNeighbours().remove(target);
						}
					});

				} else {

					popup.add(new AbstractAction("Define as neighbour",
							new ImageIcon(
									iconDir+"chainframes.png")) {
						public void actionPerformed(ActionEvent e) {
							target.setNeighbours(newNeigh);
							newNeigh.setNeighbours(target);
							
						}
					});
				}
				
			}
			if(popup.getComponentCount() > 0)
				popup.show(mouse.getComponent(), mouse.getX(), mouse.getY());
			break;

		}

		return null;
	}

	/**
	 * Recursive function which extends the frustrum on each step until atoms get in the range of the frustrum
	 * 
	 * @param ac	AtomCoordinates
	 * @param x		mouse x position 
	 * @param y		mouse y position
	 * @param genauigkeit	the accuracy which you need to hit 
	 * @return	hit item
	 */
	private boolean recuHit(double ac[], double x, double y, int genauigkeit) {
		if (ac[0] < (x + genauigkeit) && ac[0] > (x - genauigkeit)
				&& ac[1] < (y + genauigkeit) && ac[1] > (y - genauigkeit)) {
			System.out.println("HIT!");
			return true;
		} else {
			if (genauigkeit > 10)
				return false;
			else
				return recuHit(ac, x, y, genauigkeit + 1);
		}
	}

	

	public void displayChanged(GLAutoDrawable drawable, boolean modeChanged,
			boolean deviceChanged) {
	}

	// Methods required for the implementation of MouseListener
	public void mouseEntered(MouseEvent e) {
	}

	public void mouseExited(MouseEvent e) {
	}

	public void mousePressed(MouseEvent e) {
		prevMouseX = e.getX();
		prevMouseY = e.getY();
		pickPoint = e.getPoint();

		if ((e.getModifiers() & e.BUTTON3_MASK) != 0) {
			mouseRButtonDown = true;
		}
	}

	public void mouseReleased(MouseEvent e) {
		if ((e.getModifiers() & e.BUTTON3_MASK) != 0) {
			mouseRButtonDown = false;
		}
	}

	/**
	 * Stores the Mouseevent to use it in the OpenGL context
	 * @see java.awt.event.MouseListener#mouseClicked(java.awt.event.MouseEvent)
	 */
	public void mouseClicked(MouseEvent e) {
		mouse = e;
	}

	// Methods required for the implementation of MouseMotionListener
	public void mouseDragged(MouseEvent e) {
		int x = e.getX();
		int y = e.getY();
		Dimension size = e.getComponent().getSize();

		float thetaY = 360.0f * ((float) (x - prevMouseX) / (float) size.width);

		// invert mouse
		// float thetaX = 360.0f * ( (float)(prevMouseY-y)/(float)size.height);

		// normal
		float thetaX = 360.0f * ((float) (y - prevMouseY) / (float) size.height);

		prevMouseX = x;
		prevMouseY = y;

		view_rotx += thetaX;
		view_roty += thetaY;

	}

	public void mouseMoved(MouseEvent e) {
		e.getButton();
	}

	/**
	 * Stores the camposition 
	 * (Soft-Movement will be done in the Rendering method)
	 * @see java.awt.event.MouseWheelListener#mouseWheelMoved(java.awt.event.MouseWheelEvent)
	 */
	public void mouseWheelMoved(MouseWheelEvent e) {
		camdist -= (float) (e.getWheelRotation() / 2.0f);
		System.out.println("cam: " + camdist);
	}

	
	
	
}
