/**
 * 
 */
package core;

import javax.media.opengl.GL;

import com.sun.opengl.util.texture.Texture;
import com.sun.opengl.util.texture.TextureData;
import com.sun.opengl.util.texture.TextureIO;
import java.awt.image.BufferedImage;
import java.awt.image.Raster;


/**
 * @author tekkno
 *
 */
public class TextureLoader {

	/**
	 * Texture loader utilizes JOGL's provided utilities to produce a
	 * texture.
	 * 
	 * @param fileName
	 *            relative filename from execution point
	 * @return a texture binded to the OpenGL context
	 */

	public Texture load(String fileName) {
		Texture text = null;
		try {
			//BufferedImage img = new BufferedImage(new Raster(new java.io.File(fileName)));
			text = TextureIO.newTexture(new java.io.File(fileName), false);
			
			
			
			text.setTexParameteri(GL.GL_TEXTURE_MAG_FILTER, GL.GL_NEAREST);
			text.setTexParameteri(GL.GL_TEXTURE_MIN_FILTER, GL.GL_NEAREST);
			

		} catch (Exception e) {
			System.out.println(e.getMessage());
			System.out.println("Error loading texture " + fileName);
		}
		return text;
	}
	
	public TextureData loadD(String fileName){
		TextureData textd = null;
		try{
			textd = TextureIO.newTextureData(new java.io.File(fileName), false, "tga");
		} catch (Exception e) {
			e.printStackTrace();
		}
		return textd;
	}

}