/**
 * This class extends the Atom with the possibility to have neighbours and brings the base 
 * for JJ connections
 * the Connectiontype (number) and the connected Atoms will be stored in 2 Differend 
 * Stacks which allways had to have the same size.
 * they are relating on each other and have to be changed together 
 */
package objects;
import java.util.Stack;
/**
 *@see Atom
 */

public class AtomNeighbours extends Atom
{
   
   protected int neighbourCount;
   protected Stack<Integer> jj;
   protected Stack<AtomNeighbours> neighbours;

   
   /**
    * Default constructor.
    *
    */
   public AtomNeighbours(){
	   neighbours = new Stack<AtomNeighbours>();
	   jj = new Stack<Integer>();
	   neighbourCount = 0;
   }
  
   
	/**
	 * Generates a new Object with the possibilty to connect Neighbours.
	 * @param x		the x possition in the Mol 
	 * @param y		the y possition in the Mol
	 * @param z		the z possition in the Mol
	 */
	public AtomNeighbours(double x, double y, double z) {
		super(x, y, z);
		neighbours = new Stack<AtomNeighbours>();
		jj = new Stack<Integer>();
		   neighbourCount = 0;
	}	
	
   
   /**
    * Sets a new Relation between the atoms.
    * @param value	Atom which is connected to this atom
    */
   public void setNeighbours (AtomNeighbours value){
	  if(!neighbours.contains(value)){
	      neighbours.add(value);
	      jj.add(0);
	  }
   }

  /**
   * 
   * @param num	The number of the Atom in the Neighbourtable
   * @return	returns the relating atom which is stored in the Neighbour Table
   */
   public Atom getNeighbours (int num){
      return (Atom) this.neighbours.get(num);
   }
   
   /**
    * 
    * @return Number of all connected Neighbours
    */
    public int getNeighbourCount (){
    	return neighbours.size();
   }

	/**
	 * Settermethod.
	 * @param neighbourCount the neighbourCount to set
	 * @deprecated 	the count will be automical generated by the size of the Stack
	 */
    
	public void setNeighbourCount(int neighbourCount) {
		this.neighbourCount = neighbourCount;
	}

	/**
	 * Setup a new Relation.
	 * @param n		Relationg Neighbour
	 * @param _jj	Number which identifies the transaction value
	 */
	public void setNeighbourJJ(AtomNeighbours n, int _jj){
		int in = 0;
		jj.add(0);
		for (AtomNeighbours a: neighbours) {
			if (a.equals(n))
				in = neighbours.indexOf(a);
		}
		
		jj.set(in, _jj);
	}
	
	/**
	 * Returns the value of the identifier for the real transactionValue.
	 * 
	 * @param n	The connected Atom 
	 * @return	The number which marks the Transaction value. If non is found (not connected yet) this method return -1
	 */
	public int getNeighbourJJ(AtomNeighbours n){
		for (AtomNeighbours a: neighbours) {
			if (a.equals(n))
				return jj.get(neighbours.indexOf(a));
		}
		//TODO Beobachten. Vorher war hier 0 
		return -1;
	}
	
	/**
	 * @return All connected Neighbours
	 */
	public Stack<AtomNeighbours> getNeighbours() {
		return neighbours;
	}
	
	/**
	 * Returns the transactionvalue index. 
	 * @param n	Number of the Atom in the Atom Stack
	 * @return	Transaction index number. if non is found -1 will be retured
	 */
	public int getWechselwirkungsIndex(int n){
		try {
			return jj.get(n);
		} catch (Exception e){
			e.printStackTrace();
			return -1;
		}
	}
	
	/**
	 * Returns the transactionvalue index by Atom. 
	 * @param n	Atom which is connected
	 * @return	Transaction index number. if non is found -1 will be retured
	 */
	public int getWechselwirkungsIndex(AtomNeighbours n){
		
		for (AtomNeighbours a: neighbours) {
			if (a.equals(n))
				return getWechselwirkungsIndex( neighbours.indexOf(a));
		}
		//TODO changed from 0 to -1
		return -1;
		
	}
	
   
}