/**
 * Generates a BuckyBall
 */
package objects;

import java.util.Stack;

/**
 * Generates a BuckyBall
 * This is a good example how to generate a complex structure with less coding
 * @see model.Structure
 */
public class BuckyBall extends Structure {
	//TODO remove static scale factor and bring this into a good format
	static double scale = 4.0;
	static double c1 = 0.000*scale;
	static double c2 = 0.164*scale;
	static double c3 = 0.265*scale;
	static double c4 = 0.328*scale;
	static double c5 = 0.531*scale;
	static double c6 = 0.594*scale;
	static double c7 = 0.695*scale;
	static double c8 = 0.796*scale;
	
	/**
	 * 
	 * @param atome	
	 * @see model.Structure
	 */
	public BuckyBall(Stack<AtomNeighbours> atome) {
		super(atome);
		
		setScale(3);
	}

	/**
	 * default constructor
	 * @see model.Structure
	 */
	public BuckyBall() {
		
	}

	/**
	 * @see model.Structure
	 * @param _drawConnection	draw a connection between neighbours. cause of the generating no neighbours will be defined and so this option is useless until there will be neighbours
	 */
	public BuckyBall(boolean _drawConnection) {
		super(_drawConnection);
		
	}

	/**
	 * overloaded method to generate the core BuckyBall Atoms
	 */
	protected void generate() {
		AtomNeighbours bas[] = new AtomNeighbours[60];
		for (int i = 0; i < bas.length; i++) {
			bas[i] = new AtomNeighbours();
		}
		
		
		

		bas[0].x = -c3;
		bas[0].y = c4;
		bas[0].z = -c7;

		bas[1].x = -c2;
		bas[1].y = -c8;
		bas[1].z = c1;

		bas[2].x = c6;
		bas[2].y = -c5;
		bas[2].z = c2;

		bas[3].x = c1;
		bas[3].y = c2;
		bas[3].z = c8;

		bas[4].x = -c2;
		bas[4].y = -c6;
		bas[4].z = c5;

		bas[5].x = -c8;
		bas[5].y = c1;
		bas[5].z = c2;

		bas[6].x = c2;
		bas[6].y = -c6;
		bas[6].z = c5;

		bas[7].x = -c5;
		bas[7].y = c2;
		bas[7].z = -c6;

		bas[8].x = c2;
		bas[8].y = c6;
		bas[8].z = -c5;

		bas[9].x = c4;
		bas[9].y = c7;
		bas[9].z = -c3;

		bas[10].x = -c6;
		bas[10].y = -c5;
		bas[10].z = c2;

		bas[11].x = -c6;
		bas[11].y = c5;
		bas[11].z = -c2;

		bas[12].x = -c2;
		bas[12].y = -c6;
		bas[12].z = -c5;

		bas[13].x = -c3;
		bas[13].y = -c4;
		bas[13].z = -c7;

		bas[14].x = -c7;
		bas[14].y = -c3;
		bas[14].z = c4;

		bas[15].x = c7;
		bas[15].y = c3;
		bas[15].z = c4;

		bas[16].x = -c2;
		bas[16].y = c8;
		bas[16].z = c1;

		bas[17].x = c7;
		bas[17].y = c3;
		bas[17].z = -c4;

		bas[18].x = -c4;
		bas[18].y = c7;
		bas[18].z = c3;

		bas[19].x = -c7;
		bas[19].y = -c3;
		bas[19].z = -c4;

		bas[20].x = c8;
		bas[20].y = c1;
		bas[20].z = c2;

		bas[21].x = c3;
		bas[21].y = -c4;
		bas[21].z = c7;

		bas[22].x = c7;
		bas[22].y = -c3;
		bas[22].z = -c4;

		bas[23].x = c1;
		bas[23].y = -c2;
		bas[23].z = -c8;

		bas[24].x = c1;
		bas[24].y = -c2;
		bas[24].z = c8;

		bas[25].x = c2;
		bas[25].y = c6;
		bas[25].z = c5;

		bas[26].x = -c7;
		bas[26].y = c3;
		bas[26].z = -c4;

		bas[27].x = -c4;
		bas[27].y = c7;
		bas[27].z = -c3;

		bas[28].x = c2;
		bas[28].y = -c8;
		bas[28].z = c1;

		bas[29].x = c7;
		bas[29].y = -c3;
		bas[29].z = c4;

		bas[30].x = -c5;
		bas[30].y = -c2;
		bas[30].z = -c6;

		bas[31].x = c5;
		bas[31].y = c2;
		bas[31].z = c6;

		bas[32].x = c3;
		bas[32].y = c4;
		bas[32].z = c7;

		bas[33].x = c6;
		bas[33].y = c5;
		bas[33].z = -c2;

		bas[34].x = -c6;
		bas[34].y = -c5;
		bas[34].z = -c2;

		bas[35].x = c3;
		bas[35].y = -c4;
		bas[35].z = -c7;

		bas[36].x = c4;
		bas[36].y = -c7;
		bas[36].z = c3;

		bas[37].x = c8;
		bas[37].y = c1;
		bas[37].z = -c2;

		bas[38].x = -c5;
		bas[38].y = c2;
		bas[38].z = c6;

		bas[39].x = -c7;
		bas[39].y = c3;
		bas[39].z = c4;

		bas[40].x = -c3;
		bas[40].y = -c4;
		bas[40].z = c7;

		bas[41].x = c6;
		bas[41].y = -c5;
		bas[41].z = -c2;

		bas[42].x = -c2;
		bas[42].y = c6;
		bas[42].z = c5;

		bas[43].x = -c3;
		bas[43].y = c4;
		bas[43].z = c7;

		bas[44].x = c2;
		bas[44].y = c8;
		bas[44].z = c1;

		bas[45].x = -c5;
		bas[45].y = -c2;
		bas[45].z = c6;

		bas[46].x = c3;
		bas[46].y = c4;
		bas[46].z = -c7;

		bas[47].x = c2;
		bas[47].y = -c6;
		bas[47].z = -c5;

		bas[48].x = c5;
		bas[48].y = c2;
		bas[48].z = -c6;

		bas[49].x = c5;
		bas[49].y = -c2;
		bas[49].z = c6;

		bas[50].x = -c2;
		bas[50].y = c6;
		bas[50].z = -c5;

		bas[51].x = c4;
		bas[51].y = c7;
		bas[51].z = c3;

		bas[52].x = c6;
		bas[52].y = c5;
		bas[52].z = c2;

		bas[53].x = -c4;
		bas[53].y = -c7;
		bas[53].z = -c3;

		bas[54].x = c1;
		bas[54].y = c2;
		bas[54].z = -c8;

		bas[55].x = -c8;
		bas[55].y = c1;
		bas[55].z = -c2;

		bas[56].x = c5;
		bas[56].y = -c2;
		bas[56].z = -c6;

		bas[57].x = c4;
		bas[57].y = -c7;
		bas[57].z = -c3;

		bas[58].x = -c4;
		bas[58].y = -c7;
		bas[58].z = c3;

		bas[59].x = -c6;
		bas[59].y = c5;
		bas[59].z = c2;
		
		
		
		for (AtomNeighbours atom : bas) {
			atome.add(atom);
			System.out.print(".");
		}	
		
		
	}
	
}
