/**
 * 
 */
package objects;

import java.util.Stack;
import java.io.*;
import java.math.*;

import javax.media.opengl.GL;
import javax.media.opengl.glu.GLU;

/**
 * Sample object which displayes a Dedekaedron structure
 * This Object extends File and not Structure cause its using a "Helperfile"
 * which provides the additional data for the neighbour relationship
 * @see objects.File
 */
public class Dodekaeder extends File {

	
	
	/**
	 * 
	 * Constructor 
	 *
	 */
	public Dodekaeder() {
		super(true);
		
		setColor(green);
		
		//done by super object
		//readFile();
		
		setScale(5);
		
	}
	
	/**
	 * Constructor for a selfgenerated Dodekaedron
	 * @param atome	Atoms which representates the Dodekaeder
	 * @see objects.AtomNeighbours
	 */
	public Dodekaeder(Stack<AtomNeighbours> atome) {
		super(true, atome);
		setColor(green);
	
	}
	
	/**
	 * Reads a default File which descripes the neighbours based on the internal generating of the atoms
	 */

	public boolean readFile() {

		this.readNeighbours(new java.io.File("model/dodecahedron.nn"));

		return true;
	}

	/**
	 * Generates default Atoms which are formed like a Dodekaedron
	 * @see objects.Structure#generate()
	 */
	protected void generate() {
		AtomNeighbours bas[] = new AtomNeighbours[20];
		for (int i = 0; i < bas.length; i++) {
			bas[i] = new AtomNeighbours();
		}

		bas[0].x = 2.;
		bas[0].y = 0.;
		bas[0].z = .5 * (3. + Math.sqrt(5.));

		
		bas[1].x = -2.;
		bas[1].y = 0.;
		bas[1].z = -.5 * (3. + Math.sqrt(5.));

		bas[2].x = .5 * (Math.sqrt(5.) - 1.);
		bas[2].y = .5 * (Math.sqrt(10. + 2. * Math.sqrt(5.)));
		bas[2].z = .5 * (3. + Math.sqrt(5.));

		bas[3].x = -.5 * (Math.sqrt(5.) - 1.);
		bas[3].y = -.5 * (Math.sqrt(10. + 2. * Math.sqrt(5.)));
		bas[3].z = -.5 * (3. + Math.sqrt(5.));

		bas[4].x = -.5 * (Math.sqrt(5.) + 1.);
		bas[4].y = .5 * (Math.sqrt(10. - 2. * Math.sqrt(5.)));
		bas[4].z = .5 * (3. + Math.sqrt(5.));

		bas[5].x = .5 * (Math.sqrt(5.) + 1.);
		bas[5].y = -.5 * (Math.sqrt(10. - 2. * Math.sqrt(5.)));
		bas[5].z = -.5 * (3. + Math.sqrt(5.));

		bas[6].x = -.5 * (Math.sqrt(5.) + 1.);
		bas[6].y = -.5 * (Math.sqrt(10. - 2. * Math.sqrt(5.)));
		bas[6].z = .5 * (3. + Math.sqrt(5.));

		bas[7].x = .5 * (Math.sqrt(5.) + 1.);
		bas[7].y = .5 * (Math.sqrt(10. - 2. * Math.sqrt(5.)));
		bas[7].z = -.5 * (3. + Math.sqrt(5.));

		bas[8].x = .5 * (Math.sqrt(5.) - 1.);
		bas[8].y = -.5 * (Math.sqrt(10. + 2. * Math.sqrt(5.)));
		bas[8].z = .5 * (3. + Math.sqrt(5.));

		bas[9].x = -.5 * (Math.sqrt(5.) - 1.);
		bas[9].y = .5 * (Math.sqrt(10. + 2. * Math.sqrt(5.)));
		bas[9].z = -.5 * (3. + Math.sqrt(5.));

		bas[10].x = (Math.sqrt(5.) + 1.);
		bas[10].y = 0.;
		bas[10].z = .5 * (Math.sqrt(5.) - 1.);

		bas[11].x = -(Math.sqrt(5.) + 1.);
		bas[11].y = 0.;
		bas[11].z = -.5 * (Math.sqrt(5.) - 1.);

		bas[12].x = 1.;
		bas[12].y = (Math.sqrt(5. + 2. * Math.sqrt(5.)));
		bas[12].z = .5 * (Math.sqrt(5.) - 1.);

		bas[13].x = -1.;
		bas[13].y = -(Math.sqrt(5. + 2. * Math.sqrt(5.)));
		bas[13].z = -.5 * (Math.sqrt(5.) - 1.);

		bas[14].x = -.5 * (3. + Math.sqrt(5.));
		bas[14].y = .5 * (Math.sqrt(10. + 2. * Math.sqrt(5.)));
		bas[14].z = .5 * (Math.sqrt(5.) - 1.);

		bas[15].x = .5 * (3. + Math.sqrt(5.));
		bas[15].y = -.5 * (Math.sqrt(10. + 2. * Math.sqrt(5.)));
		bas[15].z = -.5 * (Math.sqrt(5.) - 1.);

		bas[16].x = -.5 * (3. + Math.sqrt(5.));
		bas[16].y = -.5 * (Math.sqrt(10. + 2. * Math.sqrt(5.)));
		bas[16].z = .5 * (Math.sqrt(5.) - 1.);

		bas[17].x = .5 * (3. + Math.sqrt(5.));
		bas[17].y = .5 * (Math.sqrt(10. + 2. * Math.sqrt(5.)));
		bas[17].z = -.5 * (Math.sqrt(5.) - 1.);

		bas[18].x = 1.;
		bas[18].y = -(Math.sqrt(5. + 2. * Math.sqrt(5.)));
		bas[18].z = .5 * (Math.sqrt(5.) - 1.);

		bas[19].x = -1.;
		bas[19].y = (Math.sqrt(5. + 2. * Math.sqrt(5.)));
		bas[19].z = -.5 * (Math.sqrt(5.) - 1.);

		System.out.println(bas.length);
		
		for (AtomNeighbours atom : bas) {
			atome.add(atom);
			System.out.print(".");
		}

		
		
	}
		
	

}
