/**
 * 
 */
package objects;

import java.io.DataInputStream;
import java.io.FileInputStream;
import java.util.Stack;

/**
 * Reads a PDB file in a simplified form. Not all data of this format will be used
 *
 * This Class can be used as an example for new fileformats which are depending on File
 */
public class FilePDB extends File {

	/**
	 * @param atome
	 */
	public FilePDB(Stack atome) {
		super(atome);
		
	}

	/**
	 * default constructor
	 */
	public FilePDB() {
		
		super(true);
		
	}
	/**
	 * Constructor
	 * @param file	file which links to the PDF file 
	 */
	public FilePDB(String file) {
		super(file);
	}
	
	/**
	 * overloaded Method which contains all specs for the PDB format
	 * @see objects.File#readFile()
	 */
	public boolean readFile(String file) {

		try {
			// Open the file that is the first
			// command line parameter
			FileInputStream fstream = new FileInputStream("model/cuban.pdb");

			// Convert our input stream to a
			// DataInputStream
			DataInputStream in = new DataInputStream(fstream);

			// Continue to read lines while
			// there are still some left to read
			int i = 0;
			int c = 0;
			int r = 0;
			while (in.available() != 0) {
				// Print file line to screen
				String tmp[] = in.readLine().split(" +");
	
				
				//skip header info
				if(r > 1){
					
					if(tmp[0].trim().equals("HETATM")){
							if (debug) System.out.println("Found Atomnode (" + i + ")");
							//ignore Atome
							atome.add(new AtomNeighbours(Double.parseDouble(tmp[5]), Double.parseDouble(tmp[6]), Double.parseDouble(tmp[7])));
					
							i++;
						/*else 
							System.err.println("Mailformed entry " + tmp);*/
							
					} else if (tmp[0].equals("CONECT")){
						if (debug) System.out.println(tmp[2]);
						
						AtomNeighbours activ = atome.get(Integer.parseInt(tmp[1])-1);
						for(int y = 1; y < tmp.length; y++){
							activ.setNeighbours
								(atome.get(Integer.parseInt(tmp[y])-1));
							if (debug) System.out.print(tmp[y] + " ");
						}
						if (debug) System.out.println("");
						c++;
					} else {
						if (debug) System.err.println("unknow word: " + tmp[0]);
					}
				
				
				}
				r++;
				
			}

			in.close();
		} catch (Exception e) {
			System.err.println("File input error");
			e.printStackTrace();
			System.exit(1);
		}

		return true;
	}
	

}
