/**
 * 
 */
package objects;

import java.util.Stack;
import com.sun.opengl.util.texture.TextureData;
import com.sun.opengl.util.texture.Texture;
import com.sun.opengl.util.texture.TextureIO;

import java.nio.Buffer;
import java.nio.IntBuffer;
import java.nio.*;

import java.io.IOException;
import java.io.InputStream;
import java.io.BufferedInputStream;
import java.io.FileInputStream;
import java.io.DataInputStream;


import core.TextureLoader;

/**
 * @author tekkno
 *
 */
public class HeightMap extends File {
	int terrainGridWidth = 0;
	int terrainGridLength = 0;
	int terrainNormals[]; 
	int terrainColors[][];
	int terrainHeights[];
	ByteBuffer coreBuf = null;
	
	ShortBuffer sb = null;
	int MAP_SIZE;
	int STEP_SIZE =2 ;
	
	private TextureData td = null; 
	/**
	 * @param atome
	 */
	public HeightMap(Stack atome) {
		super(atome);
		// TODO Auto-generated constructor stub
	}

	/**
	 * @param val
	 * @param atom
	 */
	public HeightMap(boolean val, Stack atom) {
		super(val, atom);
		// TODO Auto-generated constructor stub
	}

	public HeightMap() {
		super();
	}

	/**
	 * @param file
	 */
	public HeightMap(String file) {
		super(file);
		// TODO Auto-generated constructor stub
	}

	/**
	 * @param d
	 */
	public HeightMap(boolean d) {
		super(d);
		// TODO Auto-generated constructor stub
	}
	
	public boolean readFile() {

		core.TextureLoader tl = new TextureLoader();
		//td = tl.loadD("/tmp/test.tga");	
		/*td = tl.loadD("/tmp/heightField.raw");
		coreBuf = (ByteBuffer) td.getBuffer();
		sb = coreBuf.asShortBuffer();*/
		
		
		return true;
	}

	/*
	 * @Override
	 * (non-Javadoc)
	 * @see objects.Structure#glgenerate()
	 */
	protected void glgenerate() {
		
		//Texture tex = TextureIO.newTexture(new java.io.File("/tmp/test.tga"), false);
		//Texture tex  = new core.TextureLoader().load("/tmp/test.tga");
/*		readFile();
		Texture tex = TextureIO.newTexture(td);
		terrainGridWidth = tex.getImageWidth();
		terrainGridLength = tex.getHeight();
		MAP_SIZE = tex.getHeight() * tex.getWidth();*/
		float xOffset = (float) this.getX();
		float yOffset = (float) this.getY();
		float zOffset = (float) this.getZ();
		
		xOffset = 0;
		yOffset = 0;
		zOffset = 0;
		
		float startW,startL;
		int i,j,aux;

		// compute the initial point of the terrain on the XZ plane
		startW = (float)(terrainGridWidth / 2.0 - terrainGridWidth);
		startL = (float)(- terrainGridLength / 2.0 + terrainGridLength);
		
		startW = 0;
		startL = 0;
		// test for normals
		if (terrainNormals != null) {
			gl.glColorMaterial(gl.GL_FRONT, gl.GL_DIFFUSE);
			gl.glEnable(gl.GL_COLOR_MATERIAL);
		}

		// generate n-1 strips, where n = terrainGridLength
		// for each vertex test if colors and normals are enabled
		/*
		for(short s : sb.array()){
			System.out.print(s);
		}
		
		
		for (i = 0 ; i < terrainGridLength-1; i++) {
			gl.glBegin(gl.GL_TRIANGLE_STRIP);
			for (j = 0;j < terrainGridWidth; j++) {
				aux = 3*((i+1) * j);*/
				/*if (terrainColors != null) 
					gl.glColor3fv(terrainColors[aux], 1);
				if (terrainNormals != null)
					gl.glNormal3fv(terrainNormals[aux], 0);
				gl.glVertex3f(
					//startW + j + xOffset,
						j,
					(coreBuf.getShort(aux)+coreBuf.getShort(aux+1)+coreBuf.getShort(aux+2))
					> 20 ? 1: 0 ,
					//startL - (i+1) + zOffset
					i
					);

				//aux = 3*(i*terrainGridWidth + j);
				if (terrainColors != null) 
					gl.glColor3fv(terrainColors[aux],0);
				if (terrainNormals != null)
					gl.glNormal3fv(terrainNormals[aux],0);
				gl.glVertex3f(
					//startW + j + xOffset,
						j,
					//coreBuf.getInt(aux+3),
						0,
					//startL - i + zOffset
						i
					);					
			}
			gl.glEnd();
		}
		
		
		*/
		MAP_SIZE = 1024;
		byte[] pHeightMap = new byte[MAP_SIZE * MAP_SIZE]; ;
		 try {
	            loadRawFile("model/heightField.raw", pHeightMap);  // (NEW)
	        } catch (IOException e) {
	        	e.printStackTrace();
	            throw new RuntimeException(e);
	       }
		
		//gl.glBegin(gl.GL_TRIANGLE_STRIP);
	    gl.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset The Color
		gl.glBegin(gl.GL_QUADS);

        for (int X = 0; X < (MAP_SIZE - STEP_SIZE); X += STEP_SIZE)
            for (int Y = 0; Y < (MAP_SIZE - STEP_SIZE); Y += STEP_SIZE) {
                // Get The (X, Y, Z) Value For The Bottom Left Vertex
                int x = X;
                int y = height(pHeightMap, X, Y);
                int z = Y;

                // Set The Color Value Of The Current Vertex
                //gl.setVertexColor(pHeightMap, x, z);
                

                // Send This Vertex To OpenGL To Be Rendered (Integer Points Are Faster)
                gl.glVertex3i(x, y, z);                          

                // Get The (X, Y, Z) Value For The Top Left Vertex
                x = X;
                y = height(pHeightMap, X, Y + STEP_SIZE);
                z = Y + STEP_SIZE;

                // Set The Color Value Of The Current Vertex
                //setVertexColor(gl, pHeightMap, x, z);

                gl.glVertex3i(x, y, z);  // Send This Vertex To OpenGL To Be Rendered

                // Get The (X, Y, Z) Value For The Top Right Vertex
                x = X + STEP_SIZE;
                y = height(pHeightMap, X + STEP_SIZE, Y + STEP_SIZE);
                z = Y + STEP_SIZE;

                // Set The Color Value Of The Current Vertex
                //gl.setVertexColor(gl, pHeightMap, x, z);
                gl.glVertex3i(x, y, z); // Send This Vertex To OpenGL To Be Rendered

                // Get The (X, Y, Z) Value For The Bottom Right Vertex
                x = X + STEP_SIZE;
                y = height(pHeightMap, X + STEP_SIZE, Y);
                z = Y;

                // Set The Color Value Of The Current Vertex
                //setVertexColor(gl, pHeightMap, x, z);
                gl.glVertex3i(x, y, z); // Send This Vertex To OpenGL To Be Rendered
            }
        gl.glEnd();
       
		
		
		
		
		
		
		
	}
	
	// This Returns The Height From A Height Map Index
    private int height(byte[] pHeightMap, int X, int Y) { 

        int x = X % MAP_SIZE; // Error Check Our x Value
        int y = Y % MAP_SIZE; // Error Check Our y Value
        // Index Into Our Height Array And Return The Height
        //System.out.println("x : "+x+" y: "+y+ " mapsize: "+MAP_SIZE);
        if((x + (y * MAP_SIZE)) < pHeightMap.length && MAP_SIZE > 0) 
        	return pHeightMap[x + (y * MAP_SIZE)] & 0xFF;
        	//return pHeightMap[x + (y * MAP_SIZE)];
        else
        	return 0;
    }
    
    private void loadRawFile(String strName, byte[] pHeightMap) throws IOException {
       // InputStream input = getClass().getResourceAsStream(FileInputStream(strName));
        InputStream input  = new DataInputStream(new FileInputStream(strName));
        //new BufferedInputStream(new java.io.File(strName));
        
        readBuffer(input, pHeightMap);
        input.close();

        for (int i = 0; i < pHeightMap.length; i++)
            pHeightMap[i] &= 0xFF;                 //Quick fix
    }
    
    
    private static void readBuffer(InputStream in, byte[] buffer) throws IOException {
        int bytesRead = 0;
        int bytesToRead = buffer.length;
        while (bytesToRead > 0) {
            int read = in.read(buffer, bytesRead, bytesToRead);
            bytesRead += read;
            bytesToRead -= read;
        }
    }
    
}
