/**
 * 
 */
package objects;
/**
 * 
 * The Basic Object to describe a position of a object in 3D space. 
 * it gives all possibilities to access all coordinates and provides the getter and setter functions 
 * 
 * 
 */
public class Object3D {

	/**
	 * Object with a specified position
	 * @param x	 	x in 3D space
	 * @param y		y in 3D space
	 * @param z		z in 3D space
	 */
	public Object3D(double x, double y, double z) {
		
		this.x = x;
		this.y = y;
		this.z = z;
	}
	/**
	 * Object with 0 0 0 as default values
	 *
	 */
	public Object3D(){
		
		x= 0;
		y=0;
		z=0;
	}
	
	
	protected double x;
	/**
	 * 
	 * @param value X position in 3D Space
	 */
	public void setX(double value) {
		this.x = value;
	}

	/**
	 * 
	 * @return	X position in 3D Space (relative)
	 */
	public double getX() {
		return this.x;
	}

	protected double y;
	/**
	 * 
	 * @param value Y position in 3D Space
	 */
	public void setY(double value) {
		this.y = value;
	}
	/**
	 * 
	 * @return	Y position in 3D Space (relative)
	 */
	public double getY() {
		return this.y;
	}

	protected double z;
	/**
	 * 
	 * @param value Z position in 3D Space
	 */
	public void setZ(double value) {
		this.z = value;
	}
	/**
	 * 
	 * @return	Z position in 3D Space (relative)
	 */
	public double getZ() {
		return this.z;
	}

	public void removeYou() {
	}

	/**
	 * Returns the difference between this object and another
	 * @param obj	the other object you want to measure the differenc
	 * @return	the difference of the objects.
	 */
	public double diff(Object3D obj){
		
		return Math.sqrt( 
				(Math.pow((this.getX()-obj.getX()),2))
				+(Math.pow((this.getY()-obj.getY()),2))
				+(Math.pow((this.getZ()-obj.getZ()),2)));
	}
	
	/**
	 * 
	 * @return Valid XML / SML String representates the position in 3D space
	 */
	public String XMLAttribute(){
		if (x != 0 || y != 0 || z != 0)
			return " xyz=\""+x+";"+y+";"+z+"\"";
		return "";
	}
}
