/**
 * 
 */
package objects;

import java.util.Stack;

/**
 * 
 * Generates a simple Surface of Atoms
 * This class demonstrates how to write simple structures which get generated by a function
 * 
 */
public class Surface extends Structure {

	/**
	 * sets default values for a Surface structure
	 *
	 */
	public Surface(){
		super();
		xn = 20;
		yn = 4;
		zn = 20;
		y = -4;
		//um neue werte mit zu bekommen
		generate();
		reinit();
		
	}
	
	/**
	 * 
	 * @param atome Atoms which representates a Structure
	 */
	public Surface(Stack<AtomNeighbours> atome){
		super(atome);
	}
	
	
	/**
	 * Structure with individual settings which generates a simple plane
	 * @param xn	Atoms in X direction
	 * @param yn	Atoms in Y direction
	 * @param zn	Atoms in N direction
	 */
	public Surface(int xn, int yn, int zn) {
		super();
		this.xn = xn;
		this.yn = yn;
		this.zn = zn;
		y = -4;
		//cause the new values are only present after the super constructor.
		//so we have to do it twice :/
		generate();
		reinit();
		
	}
	

	
	
	private int xn;
	/**
	 * 
	 * @param value Atoms in X direction
	 */
	public void setXn(int value) {
		this.xn = value;
	}
	/**
	 * 
	 * @return Atoms in X direction
	 */
	public int getXn() {
		return this.xn;
	}
	
	
	private int yn;
	/**
	 * @param value Atoms in Y direction
	 *
	 */
	public void setYn(int value) {
		this.yn = value;
	}
	
	/**
	 * @return Atoms in Y direction
	 * 
	 */
	public int getYn() {
		return this.yn;
	}

	private int zn;
	/**
	 * 
	 * @param value Atoms in Z direction
	 */
	public void setZn(int value) {
		this.zn = value;
	}
	/**
	 * @return Atoms in Z direction 
	 */
	public int getZn() {
		return this.zn;
	}

	public void removeYou() {
	}

	/**
	 * @see Structure#generate()
	 */
	protected void generate() {
		/*
		 * TODO Negative startwerte fuer echte mittelpunkte
		 */
		
		System.out.println("GEN");
		

		for (int iz = zn / 2; iz > -zn / 2; iz--) {
			for (int iy = 0; iy < yn; iy++) {
				for (int ix = -xn / 2 ; ix < xn / 2; ix++) {
					AtomNeighbours tmp;
					if(iy % 2 == 0)
						tmp = new AtomNeighbours(ix * this.getScale(), -iy * this.getScale(), iz	* this.getScale());
					else 
						tmp = new AtomNeighbours(ix * this.getScale() + this.getScale() / 2, -iy * this.getScale() , iz	* this.getScale() + this.getScale() / 2);
					atome.add(tmp);
				}
			}
		}

	}
	
	

}
